      logical function dist3D(dx,dy,dz,tol)
C     Return true if the two points are very close
      integer ncont(20)
      dimension cell(6),tempf(20)
      common /sfcom1/tempf,ncont,natomq,cell
      logical aflag
      save aflag,aa,bb,ab,cc
      data aflag/.true./
      if(aflag)then
      ang=cell(6)*asin(1.0)/90.
      aa=cell(1)*cell(1)
      bb=cell(2)*cell(2)
      ab=2.*cell(1)*cell(2)*cos(ang)
      cc=cell(3)*cell(3)
        aflag=.false.
      endif
      if(abs(dx).lt.1e-6.and.abs(dy).lt.1e-6.and.abs(dz).lt.1e-6)then
        dist3D=.true.
        return
      endif
      r=dx*dx*aa+dy*dy*bb+dx*dy*ab+dz*dz*cc
      dist3D=.false.
      if(r.lt.tol*tol)dist3D=.true.
      return
      end
      real function dist3Dv(dx,dy,dz)
C     Return true if the two points are very close
      integer ncont(20)
      dimension cell(6),tempf(20)
      common /sfcom1/tempf,ncont,natomq,cell
      logical aflag
      save aflag,aa,bb,ab,cc
      data aflag/.true./
      if(aflag)then
      ang=cell(6)*asin(1.0)/90.
      aa=cell(1)*cell(1)
      bb=cell(2)*cell(2)
      ab=2.*cell(1)*cell(2)*cos(ang)
      cc=cell(3)*cell(3)
      aflag=.false.
      endif
      dist3Dv=dx*dx*aa+dy*dy*bb+dx*dy*ab+dz*dz*cc
      return
      end

