C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE ORIGL (H, K, FHK, I1, I2, SYMM, NREF )
C     defines origin for 2D unit cell
C     from convergence data
         INTEGER H(*), K(*)
         DIMENSION FHK(*)
         CHARACTER*4 SYMM
         INTEGER HE(12), KE(12), ISE(12)
 
         I1 = (-1)
         I2 = (-1)
         UBEST = (-99.)
         UB2 = -99.
C     For the moment, only along one axis
         DO   I=1,NREF
           IF (ABS (K(I)) .GT. 0) THEN
C
C     We should define a range to be accurate
C     However, let us try a simpler weighting approach
             CALL EQUIV2 (HE,KE,ISE,H(I),K(I),NA,SYMM)
             U = FHK(I) * NA / REAL (ABS (K(I)))
             IF (U .GT. UBEST) THEN
               UBEST = U
               I1 = I
             END IF
           ELSE IF ((K(I) / 2) * 2 .NE. K(I)) THEN
C     Odd value can also be set
             IF (FHK(I) .GT. UB2) THEN
               UB2 = FHK(I)
               I2 = I
             END IF
           END IF
         END DO
         RETURN
       END
 
