      double precision function rgcalw(fhk,fcalc,nref,i)
C     Input
C          fcalc       calculated intensities
C          fhk         experimental
C          nref        number of reflections
C          i           Initialize scaling flag
      dimension fhk(*),fcalc(*)
      double precision s2,s4,rgcale,rgcal3,rgcalef,t1,s5
      double precision rgshelx,rgcaler
        logical robnod,rob_fit,dwref,robfm,nodd5
        common /fscom55/robnod,rob_fit,dwref,robfm,nodd5
        include 'errref.h'
        logical itrflag
        common /trefcom/it98,it98b,it98c,itrflag
        real*8 err, scL
      include 'RefineWts.h'
      save s4 ,s5
      logical shelx
      common /shelxmode/shelx
      include 'Iconserve.h'
C
C       Calculate the R-factor error with structure factors
C       May branch depending upon Flags
C       Note: fcalc comes in as an intensity!
      if(shelx)then
C       Currently a hack
C       Shelx form
         rgcalw=rgshelx(fhk,fcalc,nref,i)
         return
      else if(rob_fit.and.robfm)then
C       Robust Chi
        rgcalw=rgcaler(fhk,fcalc,nref,i)
        return
      else if(rob_fit)then
C       R1 on Intensities
        rgcalw=rgcale(fhk,fcalc,nref,i)
        return
      else if(robfm)then
C       Chi**2 form
          rgcalw=rgcalef(fhk,fcalc,nref,i)
        return
C      else if(shelx)then
C       Shelx form
C         rgcalw=rgshelx(fhk,fcalc,nref,i)
C        return
      endif

      Include 'Iconserve1.h'

C     Get the R.M.S. error (R2)
      s1=0.0d0

      do j=1,nref
                err=fhk(j)*fhk(j)-scL*fcalc(j)
                s1=s1+err*err*sclwt(j)
      enddo
      rgcalw=sqrt(s1/SumI2)
       end
      real function rgcalws(fhk,fcalc,nref,i)
      dimension fhk(*),fcalc(*)
C      real s1,s2,s4,rgcale,rgcal3s,rgcalefs,t1,s5

        logical robnod,rob_fit,dwref,robfm,nodd5
        common /fscom55/robnod,rob_fit,dwref,robfm,nodd5
        include 'errref.h'
        logical itrflag
        common /trefcom/it98,it98b,it98c,itrflag
        real ffhk(2000), s3, err, scL
      save s4 ,s5, ffhk
      logical shelx
      common /shelxmode/shelx
C
C       Calculate the R-factor error with structure factors
C       May branch depending upon Flags
C       Note: fcalc comes in as an intensity!
      if(shelx)then
         rgcalws=rgshelxs(fhk,fcalc,nref,i)
        return
      else if(robfm)then
          rgcalws=rgcalefs(fhk,fcalc,nref,i)
        return
C      else if(shelx)then
C         rgcalws=rgshelxs(fhk,fcalc,nref,i)
C        return
      else if(rob_fit)then
        rgcalws=rgcal3s(fhk,fcalc,nref,i)
        return
      endif
      if(erron.gt.0)then
        rgcalws=rgcales(fhk,fcalc,nref,i)
        return
      endif
      if(i.lt.0)then
        s4=0
        s5=0
        do j=1,nref
                ffhk(j)=fhk(j)*fhk(j)
                s4=s4+ffhk(j)*ffhk(j)
                s5=s5+ffhk(j)
        enddo
      endif
      s3=0
      do j=1,nref
         s3=s3+fcalc(j)
      enddo
      scL=s5/s3
C     Get the R.M.S. error
      s1=0.0d0
      do j=1,nref
                err=ffhk(j)-scL*fcalc(j)
                s1=s1+err*err
      enddo
      rgcalws=sqrt(s1/s4)
      return
      end

