      subroutine gref3Dn(fhk,nref,natm,
     $  x,y,z,symm,ht,kt,lt,ng,n1,n2,n3,err,itype)
        dimension fhk(*),itype(*)
        dimension x(*),y(*),z(*),vars(200)
        character*4 symm,symmt
        integer ht(*),kt(*),lt(*),isymm
        real*8 robf3Dn,er
        equivalence (symmt,isymm)
        external gatom_1,gatom_2,gatom_3,gatom_4
        include 'rfact.h'
        include 'ffact.h'
        include 'errref.h'
        include 'Atoms.h'
        logical robnod,rob_fit,dwref,robfm,nodd5,debug
        common /fscom55/robnod,rob_fit,dwref,robfm,nodd5
        dimension cell(6),tempf(20),scale(200)
        integer ncont(20)
        common /sfcom1/tempf,ncont,natomq,cell
        common /fscom43/slw1,slw2,secval,debug,basecut
        dimension aocc(20),zatom(20)
        common /sfcom2/aocc,zatom,forig,brownf,dmult,dmlt
        dimension W(natf*3*7*9),G(natf*3)
        real*8 praxism, fmin, gatom0 ,vars2(200)
        external gatom0
C
        dimension work(100)
        integer iwork(100)
        logical lwork(100)
        common /conminw/work,iwork,lwork
C       
C       Reduce the atoms to within the unit cell (????)
        do j=1,natm
                call ASUWNT (X(j), Y(j), SYMM )
        enddo
C       Find correction term for number of variables
        call chinumb(x,y,natm,itype,symm,nchi)
        chifactor = float(nrref)/max(1.,float(nrref-nchi))
C       Ensure that centering is detected
        call centered(symm)
C       Find number of D.W. terms
      ndw=0
C     Force D.W. ref off
C      dwref=.false.
        if(dwref)then
          do j=1,20
                if(zatom(j).gt.-0.1)then
                        ndw=ndw+1
                endif
          enddo
C         Only refine a single, global DW term
          ndw=1
        endif
        symmt=symm
        iwork(1)=ndw
        iwork(2)=nrref
        iwork(3)=isymm
        lwork(1)=dwref
        n=natm*3
        m=0
        noff=4
        do j=1,n,3
                m=m+1
                vars(j)  =x(m)
                vars(j+1)=y(m)
C               vars(j+2)=z(m)
                vars(j+2)=0
                iwork(m+noff)=itype(m)
        enddo
        if(dwref)then
                ndw=1
                do j=1,20
                        tempf(j)=abs(tempf(1))
                        vars(n+1)=tempf(j)-0.075
                enddo
                n=n+1
        endif

C       Look at the point - maybe nothing viable!
        if(n.eq.0)then
                err=1e4
                goto 10
        endif   
C        write(6,*)'Entry ',err,nrref,symm,natm
        err=robf3Dn(rfhk,nrref,
     $        natm,x,y,z,symm,rh,rk,rl,itype,-1)
C        write(6,*)'Entry ',err,nrref,symm,natm
C        do j=1,5
C           write(6,*)rfhk(j),rh(j),rk(j),rl(j)
C        enddo
        if(err.gt.1e4)goto 10
        if(.not.bfgs_abort)then
C              write(10,*)'PRAXIS REFINEMENT !!'
              do j=1,natm
                 jj=2*j-1
                 vars2(jj)  =x(j)
                 vars2(jj+1)=y(j)
              enddo
              n=natm*2
              if(dwref)then
                do j=1,20
                        tempf(j)=abs(tempf(j))
                        vars2(1+n)=tempf(j)-0.075
                enddo
                n=n+1
              endif
              FF=praxism(N,vars2,gatom0,FMIN)
              m=0
              n=natm*2
              do j=1,n,2
                m=m+1
                x(m) = vars2(j)
                y(m) = vars2(j+1)
C     Cleanup atoms close to symmetry points
                call cleaner(x(m),y(m),symm,0.5)
                if(debug)write(14,8)m,x(m),y(m),z(m)
              enddo
              if(dwref)then
                do j=1,20
                        tempf(j)=vars2(1+n)
                        tempf(j)=abs(tempf(j))+0.075
                        if(debug)write(14,9)j+n,tempf(j)
                enddo
              endif
C             NMETH=0
C             MXFUN=NG*3
C             EPS=1E-4
C             IOUT=3
C             MDIM=N*(N+7)/2
C             ACC=1E-12
C             IDEV=6
C             CALL CONMIN(N,vars,F,G,IFUN,ITER,EPS,NFLAG,MXFUN,W,
C     1       IOUT,MDIM,IDEV,ACC,NMETH)
C             do j=1,n
C                write(6,*)vars(j),g(j)
C             enddo
C             write(6,*)nflag
        else
C        write(10,*)'LDM REFINEMENT'
        icond=-1
        call ref_gen(vars,n,work,iwork,lwork,scale,debug,gatom_1
     1  ,gatom_2,gatom_3,icond,gatom_4,ng,er)
C        endif
        n=natm*3
        m=0
        do j=1,n,3
                m=m+1
                x(m) = vars(j)
                y(m) = vars(j+1)
C               z(m) = vars(j+2)
                z(m) = 0
C     Cleanup atoms close to symmetry points
                call cleaner(x(m),y(m),symm,0.5)
                if(debug)write(14,8)m,x(m),y(m),z(m)
8       format(i2,3f10.4,3e10.3)
        enddo
        if(dwref)then
                do j=1,20
                        tempf(j)=vars(1+n)*scale(1+n)
                        tempf(j)=abs(tempf(j))+0.075
                        if(debug)write(14,9)j+n,tempf(j),scale(j+n)
9       format(i2,f10.4,e10.3)
                enddo
        endif
      endif
      err=robf3Dn(rfhk,nrref,
     $        natm,x,y,z,symm,rh,rk,rl,itype,-1)
C       Correction for the number of variables in Chi**2 fit
10    if(debug)write(6,*)'Output trap ',err,er
C      if(erron.gt.7)then
C      call chinumb(x,y,natm,itype,symm,nchi)
C      err=err*err*nrref/(nrref-nchi)
C      err=sqrt(err)
C      endif
      return
      end
       SUBROUTINE CALCFG(N,X,F,G)
        dimension work(100)
        integer iwork(100)
        logical lwork(100)
        common /conminw/work,iwork,lwork
        dimension X(N),G(N),XT(300)
        dimension scale(300)
        real*8 gatom_1,err1,err2,dstep,dscale(300)
        include 'cellcon.h'
        j=0
        do j1=1,n,3
           do j2=1,3
              j=j+1
              dscale(j)=1.D0/cell(j2)
           enddo
        enddo
        do j=1,n
               xt(j)=x(j)
               g(j)=0
               scale(j)=1
        enddo
        F= gatom_1(work,iwork,lwork,scale,xt,n)

            dstep=1d-3
            do j=1,n
C              Avoid z
               if( (j/3)*3 .eq. j)goto 110
C               jj=j-1
C             if( (jj/3)*3 .eq. jj) write(6,*)' '
               xt(j)=x(j)+dstep*dscale(j)
               err1= gatom_1(work,iwork,lwork,scale,xt,n)
               do jq=1,n
                  xt(jq)=x(jq)
               enddo
               xt(j)=x(j)-dstep*dscale(j)
               err2= gatom_1(work,iwork,lwork,scale,xt,n)
               g(j)=(err1-err2)/(2.D0*dstep*dscale(j))*0.01D0
               write(6,*)g(j),x(j),xt(j),F
               do jq=1,n
                  xt(jq)=x(jq)
               enddo
110            continue
             enddo
        return
        end
