        subroutine alister(x,y,z,nlist,itype,symm,cell,
     1  zatom,aocc,ncont,sfacts,rerr)
        character*4 symm
        dimension x(*),y(*),z(*),itype(*),cell(*)
        character*4 sfacts(*)
        dimension zatom(*),aocc(*),ncont(*)
        dimension xe(20),ye(20),igot(10)
        include 'Constraints.h'
        do j=1,10
                igot(j)=0
        enddo
C
C       Output an '.ins' file
        open(unit=12,file='Refined.ins')
        write(12,22)rerr,r1fact
22      format('TITL G-of-Fit ',f9.5,' R1 ',f9.5)
        write(12,1)(cell(j),j=1,6)
1       format('CELL 0.45 ',3f8.4,3f7.1)
        write(12,2)'ZERR 1 .001 .001 .001 0 0 0'
2       format(a)
        write(12,2)'REM edm fitted positions'
        if(symm.eq.'c2mm')then
                write(12,2)'LATT -7'
                write(12,2)'SYMM -X, -Y, Z'
                write(12,2)'SYMM  X, -Y, Z'               
                write(12,2)'SYMM -X,  Y, Z'
        else if(symm.eq.'p2mm')then
                write(12,2)'LATT -1'
                write(12,2)'SYMM -X, -Y, Z'
                write(12,2)'SYMM  X, -Y, Z'               
                write(12,2)'SYMM -X,  Y, Z'
        else if(symm.eq.'p2  ')then
                write(12,2)'LATT -1'
                write(12,2)'SYMM -X, -Y, Z'
        else if(symm.eq.'pm  '.or.symm.eq.'p1m1')then
                write(12,2)'LATT -1'
                write(12,2)'SYMM -X, Y, Z'
        else if(symm.eq.'cm  '.or.symm.eq.'c1m1')then
                write(12,2)'LATT -7'
                write(12,2)'SYMM -X, Y, Z'
        else if(symm.eq.'p11m  ')then
                write(12,2)'LATT -1'
                write(12,2)'SYMM  X, -Y, Z'
        else if(symm.eq.'c11m  ')then
                write(12,2)'LATT -7'
                write(12,2)'SYMM  X, -Y, Z'
        else if(symm.eq.'p4  ')then
                write(12,2)'LATT -1'
                write(12,2)'SYMM -X, -Y, Z'
                write(12,2)'SYMM -Y,  X, Z'               
                write(12,2)'SYMM  Y, -X, Z'
        else if(symm.eq.'p4mm')then
                write(12,2)'LATT -1'
                write(12,2)'SYMM -X, -Y, Z'
                write(12,2)'SYMM -Y,  X, Z'               
                write(12,2)'SYMM  Y, -X, Z'
                write(12,2)'SYMM -X,  Y, Z'
                write(12,2)'SYMM  X, -Y, Z'
                write(12,2)'SYMM  Y,  X, Z'               
                write(12,2)'SYMM -Y, -X, Z'
        else if(symm.eq.'p3  ')then
                write(12,2)'LATT -1'
                write(12,2)'SYMM  -Y, X-Y, Z'
                write(12,2)'SYMM Y-X,  -X, Z'               
        else if(symm.eq.'p3m1')then
                write(12,2)'LATT -1'
                write(12,2)'SYMM  -Y, X-Y, Z'
                write(12,2)'SYMM Y-X,  -X, Z'
                write(12,2)'SYMM  -Y,  -X, Z'              
                write(12,2)'SYMM Y-X,   Y, Z'
                write(12,2)'SYMM   X, X-Y, Z'               
        else if(symm.eq.'p31m')then
                write(12,2)'LATT -1'
                write(12,2)'SYMM  -Y, X-Y, Z'
                write(12,2)'SYMM Y-X,  -X, Z'
                write(12,2)'SYMM   Y,   X, Z'              
                write(12,2)'SYMM X-Y,  -Y, Z'
                write(12,2)'SYMM  -X, Y-X, Z'               
        else if(symm.eq.'p6  ')then
                write(12,2)'LATT -1'
                write(12,2)'SYMM  -Y, X-Y, Z'
                write(12,2)'SYMM Y-X,  -X, Z'
                write(12,2)'SYMM  -X,  -Y, Z'              
                write(12,2)'SYMM   Y, Y-X, Z'
                write(12,2)'SYMM X-Y,   X, Z'               
        else if(symm.eq.'p6mm')then
                write(12,2)'LATT -1'
                write(12,2)'SYMM  -Y, X-Y, Z'
                write(12,2)'SYMM Y-X,  -X, Z'
                write(12,2)'SYMM  -X,  -Y, Z'              
                write(12,2)'SYMM   Y, Y-X, Z'
                write(12,2)'SYMM X-Y,   X, Z'               
                write(12,2)'SYMM X-Y,  -Y, Z'
                write(12,2)'SYMM  -X, Y-X, Z'
                write(12,2)'SYMM  -Y,  -X, Z'
                write(12,2)'SYMM Y-X,   Y, Z'
                write(12,2)'SYMM   X, X-y, Z'
                write(12,2)'SYMM   Y,   X, Z'
        endif
      nt=0
      do j=1,20
         if(zatom(j).gt.-0.1)then
         nt=nt+1
         endif
      enddo
        ntmax=nt
        write(12,3)(sfacts(j),j=1,nt)
3       format('SFAC ',12(a,' '))
        write(12,4)(ncont(j),j=1,nt)
4       format('UNIT',i3,12i4)
        do j=1,nlist
        nt=itype(j)
        call asymm(x(j),y(j),ne,xe,ye,symm)
        igot(nt)=igot(nt)+ne
        if(sfacts(nt)(2:2).eq.' ')then
                if(j.lt.10)then
                write(12,10)sfacts(nt)(1:1),j,itype(j),x(j),y(j),z(j)
                else
                write(12,11)sfacts(nt)(1:1),j,itype(j),x(j),y(j),z(j)
                endif
C       Recognize +/-
        else if((sfacts(nt)(3:3).eq.'+').or.(sfacts(nt)(3:3).eq.'-').or.
     1      (sfacts(nt)(4:4).eq.'+').or.(sfacts(nt)(4:4).eq.'-'))then
                write(12,24)sfacts(nt),itype(j),x(j),y(j),z(j)
        else
                if(j.lt.10)then
                write(12,20)sfacts(nt)(1:2),j,itype(j),x(j),y(j),z(j)
                else
                write(12,21)sfacts(nt)(1:2),j,itype(j),x(j),y(j),z(j)
                endif
        endif
10      format(a,'0',i1,'   ',i2,3f8.5)
11      format(a,i2,    '   ',i2,3f8.5)
20      format(a,'0',i1, '  ',i2,3f8.5)
21      format(a,i2,     '  ',i2,3f8.5)
24      format(a,        '  ',i2,3f8.5)
        enddo
        write(12,23)(sfacts(j)(1:2),igot(j),j=1,ntmax)
23      format('REM ',10(a,i3,' '))
        write(12,2)'END'
        close(unit=12)
        return
        end
                
