       Subroutine POT3DR(P,IH,KB,LB,NRF,D,L,
     $ VSUMZ,CT,NTYPE,F0,xray)
C     ROUTINE TO GENERATE POTENTIAL TERMS
C
        include 'controls.h'
       DIMENSION P(*)
C       INTEGER ATOM1,ATOM2,ATOM3
       DIMENSION L(9),D(3),X(5),Y(5)
	 dimension xi(4,-1:1),yi(4,-1:1),zz(-1:1),cx(-1:1)
       real*8 D11,D12,D22,XII,XJ,XJ2,XIJ,FIJN,CT2,DTEMP,XT
	 real*8 fi(-1:1),first,second
       integer IH(*),KB(*),LB(*)
       logical xray,interp
       character*4 csymb
	common /DBterm/btemp
	dimension atsc(2000,5),xat(2000)
	save atsc,xat
	character*1 ctmp
	logical OK
C	save icounter
C	data icounter/0/
C	Tack a term at the end, trap for a bug (?)
	NREF=nrf+1
	IH(nref)=0
	KB(nref)=0
	LB(nref)=0
	NF=4
C
	F0=0.0
       D11=0.25 /(D(1)*D(1))
       D22=0.25 /(D(2)*D(2))
       CT2=CT
       D12=0.5 /(D(1)*D(2))
       D33=0.25/(D(3)*D(3))
C     LOOP OVER TYPES OF ATOMS
       DO 320 N=1,NTYPE
C     READ PARAMETERS FOR EACH TYPE OF ATOM
      temp=abs(tempf(n))
      csymb=sfacts(n)
      num=ncont(n)
C     dumc=csymb
C     atom2=ichar('    ')
C     atom3=atom2
      frac=aocc(n)
      itemp=0
      ixray=1
      zsumn=0
C	Do we have an integer, i.e. superimpose two atoms ?
	ifirst=-1
	do j=1,9
		write(ctmp,1000)j
1000		format(i1)
		if(csymb(1:1).eq.ctmp)ifirst=j
	enddo
	if(ifirst.gt.0)then
C	   Yes case, find second value
	   isecnd=-1
	   do j=1,9
		write(ctmp,1000)j
		if(csymb(2:2).eq.ctmp)isecnd=j
	   enddo
	   if(isecnd.lt.1)then
		write(10,*)'Invalid Type ',csymb(1:2)
		call exit(1)
	   endif
	   do J=1,nref
		rfact(j,n)=rfact(j,ifirst)+rfact(j,isecnd)
	   enddo
	   zatom(n)=zatom(ifirst)+zatom(isecnd)
	   zsumr(n)=zsumr(ifirst)+zsumr(isecnd)
           goto 320
        endif
        
	interp=.false.
C	if(csymb(4:4).eq.'+'.or.csymb(4:4).eq.'-')then
C		interp=.true.
C		call scattfi(cx,xi,yi,zz,csymb,charge)
C		cxray=cx(0)
C		zizz=zz(0)
C		do j=1,4
C			x(j)=xi(j,0)
C			y(j)=yi(j,0)
C		enddo
C	else
C     New version
      call scattf(cxray,x,y,zizz,csymb,charge)
      call nsfac(x,y,cxray,csymb,ok,zizz)
      NF=5
      if(.not.ok)then
        call scattf(cxray,x,y,zizz,csymb,charge)
        NF=4
      endif
C      endif
C
C     FRACTIONAL OCCUPANCY ?
 10    IF(FRAC.LE.0.0 )GO TO 30
       DO 20 M=1,NF
 20    X(M)=FRAC*X(M)
       ZIZZ=ZIZZ*FRAC
       CXRAY=CXRAY*FRAC
C	write(10,*)'Dump x,y ',x,y,zizz,xray,d,temp
C
C       X-RAY DATA
C     OUTPUT OF PARAMETERS
C      WRITE(10,360)NUM,csymb,ZIZZ,FRAC,TEMP
30	continue
C
C
 50    IP=0
c
       DO 80 J=1,nref
       if(.not.gotrfacts)then
       	XJ=KB(J)
       	XII=IH(J)
C	Note: correction for subsampling along z, was 1/izsamp
       	XL=float(LB(J))
       	XJ2=XJ*XJ*D22+XL*XL*D33
       	XIJ=XJ*CT2*D12
       	XSQQ=-(XJ2+XIJ*XII+XII*XII*D11)
       	xat(j)=xsqq
       else
       	xsqq=xat(j)
       endif
       FIJN=0.0 
c
c     include temperature factor
      dtemp=xsqq*dble(temp)
      if(dtemp.lt.-15. )goto 70
      
      if(.not.gotrfacts)then
	if(interp)then
C	****** Start Interpolative case *********
	do ji=-1,1
		FI(ji)=dble(CX(ji))
       	DO M=1,4
       	XT=dble(YI(M,ji))*XSQQ
       	if(xt.gt.-40.)FI(ji)=FI(ji)+dble(XI(M,JI))*EXP(XT)
		enddo
C
	enddo
C	First-order term
	First=(FI(1)-FI(-1))*0.5d0
C	Second-order term
	Second=(FI(1)+FI(-1)-2.d0*FI(0))*0.5d0
C	Interpolation
	FIJN=FI(0)+dble(charge)*(First+dble(charge)*Second)
C     MOTT FORMULA 
         IF(XSQQ.lT.-1E-10)then
		FIJN=(FIJN-dble(ZZ(0)))*0.023934D0/XSQQ
	   else
		FIJN=0.023934D0*(XI(1,0)*YI(1,0)+XI(2,0)*YI(2,0)+
     1 	XI(3,0)*YI(3,0)+XI(4,0)*YI(4,0))
	   endif

C	****** End Interpolative case *********
	else
C	****** Start Non-interpolative case *********
       	DO 60 M=1,NF
       	XT=dble(Y(M))*XSQQ
       	if(xt.gt.-40. )FIJN=FIJN+dble(X(M))*EXP(XT)
 60    	CONTINUE
C
	if(xray)then
	 	FIJN=(FIJN+dble(CXRAY))
	else
C     MOTT FORMULA 
         IF(XSQQ.lT.-1E-10)then
		FIJN=(FIJN+dble(CXRAY-ZIZZ))*0.023934D0/XSQQ
	   else
		FIJN=0.023934D0*(X(1)*Y(1)+X(2)*Y(2)+
     1 	X(3)*Y(3)+X(4)*Y(4))
           if(NF.eq.5)FIJN=FIJN+0.023934D00*X(5)*Y(5)
	   endif

      endif
C	****** End Non-interpolative case *********
	endif
c
	atsc(j,n)=fijn
      else
      	fijn=atsc(j,n)
      endif
       fijn=fijn*exp(dtemp)
c     trap here for no negative terms
      if(fijn.lt.0.0d0)fijn=0.0d0
 70	continue
	rfact(j,N)=FIJN
	zsumn=zsumn+FIJN
C	if(icounter.lt.5)then
C	write(10,888)ih(j),kb(j),lb(j),fijn,xsqq,dtemp,atsc(j,n)
C	endif
888	format(3i4,7f12.5)
 80    CONTINUE

C    ZERO TERM FOR X-RAY CASE
C
151    if(xray)then
       	fijn=ZIZZ
       	vsumz=VSUMZ+float(num)*fijn
        f0=f0+float(num)*fijn*fijn
        FZERO=zizz
       else

       	fijn=0.023934D00*(X(1)*Y(1)+X(2)*Y(2)+
     1 	X(3)*Y(3)+X(4)*Y(4))
        if(NF.eq.5)FIJN=FIJN+0.023934D00*X(5)*Y(5)
       	vsumz=VSUMZ+fijn*num
        FZERO=fijn
        f0=f0+float(num)*fijn*fijn
        zsumn=zsumn+fijn
       endif
 130	btemp=temp
C
C     Save zero term
      zatom(n)=fzero
      zsumr(n)=zsumn

C	Patch to change zatom for charges?
	if(abs(charge).gt.1e-3)zatom(n)=zatom(n)+charge
c
 300   CONTINUE
C
 320   CONTINUE
c
c	Take the sqrt for normalization
C       DO 301 K=1,nref
C 301   P(k)=sqrt(P(k))
c       Correct F0 to approximate number of atoms
        F0=vsumz*vsumz/f0
c	If NTYPE=1 and NUM=1 we have <F**2>=1 normalization in use
c	Trap this by setting F0=-1
	if(ntype.eq.1.and.num.eq.1)F0=-1.
c	output z*occ and relative integrated values
	zsmm=-99
	zatm=-99
	do j=1,ntype
		if(zatom(j).gt.zatm)zatm=zatom(j)
		if(zsumr(j).gt.zsmm)zsmm=zsumr(j)
	enddo
C	write(19,*)
C	write(19,*)'Relative Weights'
500	format(' Type ',i2,' Z*Occ ',f8.4,' Zsum ',f8.4)
	do j=1,ntype
C	zatom(j)=zatom(j)/zatm
	zsumr(j)=zsumr(j)/zsmm
C	write(10,500)j,zatom(j),zsumr(j)
	enddo
C	icounter=icounter+1
       RETURN
C
 360   FORMAT(/4X,' It contains ',I4,' ',A,' atoms, Z=',F8.4
     1/4x,' Occupancy ,',F6.3,' with Temperature Factor (B=8*pi*pi*U)'
     2 ,F9.5)
 380   FORMAT(9F8.5)
 390   FORMAT(1H ,9F13.4)
 400   FORMAT(10F8.3)
 410   FORMAT(1H ,3F10.6)
 420   FORMAT(3F10.6)
       END

