C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE PATTS (SYIN, SYMM )
         CHARACTER*4 SYMM, SYIN
C     Convert from Plane Group to Patterson Symmetry
C     Default to input
         SYMM = SYIN
         IF (SYIN .EQ. 'pg  ' .OR. SYIN .EQ. 'pm  ') THEN
           SYMM = 'p2mm'
         ELSE IF (SYIN .EQ. 'p11m' .OR. SYIN .EQ. 'p11g') THEN
           SYMM = 'p2mm'
         ELSE IF (SYIN .EQ. 'p1m1' .OR. SYIN .EQ. 'p1g1') THEN
           SYMM = 'p2mm'
         ELSE IF (SYIN .EQ. 'p1  ') THEN
           SYMM = 'p2  '
         ELSE IF (SYIN .EQ. 'cm  ' .OR. SYIN .EQ. 'c1m1') THEN
           SYMM = 'c2mm'
         ELSE IF (SYIN .EQ. 'c11m') THEN
           SYMM = 'c2mm'
         ELSE IF (SYIN(1:3) .EQ. 'p2m' .OR. SYIN(1:3) .EQ. 'p2g') THEN
           SYMM = 'p2mm'
         ELSE IF (SYIN .EQ. 'p4gm' .OR. SYIN .EQ. 'p4mg') THEN
           SYMM = 'p4mm'
         ELSE IF (SYIN .EQ. 'p3  ') THEN
           SYMM = 'p6  '
         ELSE IF (SYIN(1:2) .EQ. 'p3') THEN
           SYMM = 'p6mm'
         END IF
         RETURN
       END
