C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE SHPT2D (N1, N2, M, C, IOPT, X1, X2 )
         COMPLEX C(*)
         INTEGER M(3), N1, N2, IOPT
         DOUBLEPRECISION XMEAN, X, XR, XI, FTEMP, ATMAX
         DOUBLEPRECISION XMEANH,TMP,FTEMPH,FENTR
         INTEGER NCONT(20)
         DIMENSION CELL(6), TEMPF(20), AOCC(20), ZATOM(20)
         LOGICAL FORIG, FSEMP, BROWNF, DMULT, DMLT, FOM2
         Include 'Sfacts.h'
         COMMON /SFCOM1/TEMPF, NCONT, NATOM, CELL
         COMMON /SFCOM2/AOCC, ZATOM, FORIG, BROWNF, DMULT, DMLT
         COMMON /MVIS/WIDTH, HEIGHT, TIMES, FSEMP
         COMMON /COPT/ATNUM, PATTC, ACTERM, FOM2
         COMMON /FOMALL/ER1, EI1, EC1, F0PASS
         DIMENSION FSTEST(20)
         COMMON /COPT2/FSTEST
         INTEGER LAT(2)
         COMMON /CLAT/LAT
         SAVE /COPT2/ , /COPT/ , /MVIS/ , /SFCOM2/ , /SFCOM1/
         DOUBLE PRECISION DD1
         LOGICAL LL1
C         COMMON /NEWSTUFF/POWER, FLIP
         include 'NewStuff.h'
         LOGICAL CENTRO, UFLIP
         COMMON /CCENTR/CENTRO
C     Positivity constraint as well
C     Do a FFT
         CALL FFT2DN (C)
         UFLIP=.false.
         if(flip.gt.1e-4)uflip=.true.
C           Correction for the origin shift
C           Quench any imaginary component as a rounding error
C     Also find max, min and mean at the same time
C         XMEAN = 0.D0
         JK = 0
         MF = (-1)
C         XMAX = (-1.D0)
         DO   I=1,N2
           MF = -MF
           NF = (-MF)
           DO   J=1,N1
             JK = JK + 1
             NF = -NF
             X = dble(C(JK)) * dble(NF) 
             C(JK) = X 
             XMEAN = XMEAN + X
C             IF (X .GT. XMAX) XMAX = X
           END DO
         END DO
         IF (ATNUM .GT. 1) ATMAX = ACTERM * N1 * N2 / ATNUM
C         write(6,*)'Sum of values (1.0 ?) ',xmean,n1,n2,FNATM

C       fs2002 partway atoms-like term -- new default
        INCLUDE 'EntScales.h'
C
C        write(6,*)'Odd ',xmean,ftemp,tmp,fnatm
C       Centro, nothing is the default case
C        write(6,*)TMP,FNATM,XMEAN,FTEMP
C        IF(LENTR)X0 = X0/TMP/3.d0
C        XMAX = XMAX * 0.2D0 / XMEAN
C     X*ln(X) case only
         JK = 0
         MF = (-1)
         LL1 = ATNUM .GT. 1
         DD1 = 1.25D0 * ATMAX
         DO   I=1,N2
           MF = -MF
           NF = (-MF)
           DO   J=1,N1
             NF = -NF
             JK = JK + 1
C
             X = DBLE (C(JK)) / XMEAN
             IF (X .LT. 1D-8) THEN
               XR = 0.D0
C       Discontinue positivity over-relaxation
                XI = 0.D0
             ELSE
               XR = X * LOG (X)
               XI = X
             END IF
C            Flipping term, reverse if X/XMEAN < FLIP
             IF(UFLIP .and. (X.LT.FLIP))XI = -X
             XR = XR * DBLE(NF)*FTEMP
             XI = XI * DBLE(NF)*XMEAN
             C(JK) = CMPLX (XR, XI)
           END DO
         END DO
 
C     Invert
         CALL FFT2DP (C)
         RETURN
       END
 
