C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE NORM (FHK, H, K, SYMM, NREF )
         CHARACTER*4 SYMM
         INTEGER H(*), K(*), HE(20), KE(20), ISE(20)
         DIMENSION FHK(*)
         logical cellcent
         include 'NewStuff.h'
C         COMMON /NEWSTUFF/POWER,FLIP
         REAL RR1
C     Normalization - sum to fterm and V00 to 1
C     Also take power if relevant, and find if effective cell has centering
        cellc=cellcent(symm)
        call cntrd(symm)
         FSUM = 0.
         II=NREF
         DO   N=1,NREF
           IF (H(N) .EQ. 0 .AND. K(N) .EQ. 0) THEN
             II = N
           ELSE
             IF(POWER.GT.0.1.AND.FHK(N).GT.1e-7)THEN
             	FHK(N)=FHK(N)**POWER
             ENDIF
             CALL EQUIV2 (HE,KE,ISE,H(N),K(N),NE,SYMM)
             FSUM = FSUM + FHK(N) * FHK(N) * NE
           END IF
         END DO
         FSUM = SQRT (FSUM)
         DO   N=1,NREF
           RR1 = FHK(N)
           FHK(N) = RR1 / FSUM
         END DO
         FHK(II) = 1.
         RETURN
       END
