c 
c  Copyright (c) 1998 L. D. Marks
c 
c  This program is free software; you can redistribute it and/or modify
c  it under the terms of the GNU General Public License as published by
c  the Free Software Foundation; either version 2 of the License, or
c  (at your option) any later version.
c 
c  This program is distributed in the hope that it will be useful,
c  but WITHOUT ANY WARRANTY; without even the implied warranty of
c  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c  GNU General Public License for more details.
c 
c  You should have received a copy of the GNU General Public License
c  along with this program; if not, write to the Free Software
c  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
c 
c
       Subroutine Potatom(P,IH,KB,LB,NREF,N,F0,xray)
C     ROUTINE TO GENERATE POTENTIAL TERMS FOR ATOM
	integer ncont(20)
	dimension cell(6),tempf(20),aocc(20),zatom(20)
         Include 'Sfacts.h'
         COMMON /SFCOM1/TEMPF, NCONT, NATOM, CELL
         LOGICAL FORIG, FSEMP, BROWNF, DMULT, DMLT, FOM2
         COMMON /SFCOM2/AOCC, ZATOM, FORIG, BROWNF, DMULT, DMLT
	common /mvis/width,height,times, FSEMP
c
       DIMENSION P(*)
       DIMENSION D(3),X(4),Y(4)
       integer IH(*),KB(*),LB(*)
       logical xray
       character*4 csymb, dumc
C
       A=cell(1)
       B=cell(2)
       gamma=cell(6)
	pf=asin(1.D0)/90.D0
	ang=(180.d0-gamma)*pf 
	ang2=asin(1.d0)-ang
	CT=cos(ang)
	D1=1.d0/(A*cos(ang2))
	D2=1.d0/(B*cos(ang2))      
C       write(6,*)a,b,gamma
       D11=0.25 * D1 * D1
       D22=0.25 * D2 * D2
       D12=0.5  * D1 * D2
       CT2=CT*D12
C       write(6,*)D,CT
C     LOOP OVER TYPES OF ATOMS
	temp=tempf(n)
	csymb=sfacts(n)
	num=ncont(n)
	dumc=csymb
	itemp=0
	ixray=1
       call scattf(cxray,x,y,zizz,csymb)
C       write(6,*)temp,csymb,num,dumc
C       write(6,*)D11,D22,CT2
C
       DO 80 J=1,nref
       XJ=KB(J)
       XI=IH(J)
       XJ2=XJ*XJ*D22
       XJI=XJ*CT2
       XSQQ=-(XJ2+XI*(XJI+XI*D11))
       FIJN=0.0 
c
c     include temperature factor
      dtemp=xsqq*dble(temp)
      if(dtemp.lt.-40. )goto 70
       DO 60 M=1,4
       XT=dble(Y(M))*XSQQ
       if(xt.gt.-40. )FIJN=FIJN+dble(X(M))*EXP(XT)
 60    CONTINUE
C
C     MOTT FORMULA FOR XRAY CASE
	if(xray)then
	 FIJN=(FIJN+dble(CXRAY))
	else
         IF(IXRAY.NE.0.AND.XSQQ.lT.-1E-10
     1   )FIJN=(FIJN+dble(CXRAY-ZIZZ))*0.0239340/XSQQ
        endif
c
       fijn=fijn*exp(dtemp)
c     trap here for no negative terms
      if(fijn.lt.0.0d0)fijn=0.0d0
 70    P(J)=FIJN
C       write(20,*)j,ih(j),kb(j),lb(j),xsqq,fijn,xsqq
 80    CONTINUE

C    ZERO TERM
C
151    if(xray)then
       	f0=ZIZZ
       else
       	f0=0.023934D00*(X(1)*Y(1)+X(2)*Y(2)+
     1 	X(3)*Y(3)+X(4)*Y(4))
       endif
c
       RETURN
       END

