C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE FINDSZ (IH, K, NREF, SYMM, M, IOPT )
C     find an appropriate size for m that avoids aliasing
         INTEGER IH(NREF), K(NREF), HE(20), KE(20), ISE(20)
         INTEGER M(3), HMAX, KMAX
         CHARACTER*4 SYMM
         LOGICAL SPRRES
         include 'Nlimit.h'
C         PARAMETER (NHK2 = 900, NLIMIT = 65536)
         LOGICAL PRINTF
         COMMON /PRINTS/PRINTF
C         DIMENSION WINWTS(NHK2)
C         COMMON /FOM5/WINWTS
         LOGICAL PWMASK, EOPT, PWACC, PMACC
         COMMON /WALSH/PWMASK, EOPT, PWACC, PMACC
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
C     data centro /.false./
         COMMON /ERRTRY/NWOPT
         COMMON /ENTC2D/RAD1, RAD2 
C     For tuning
         LOGICAL TLOG(6)
         DIMENSION FTUNE(4)
         COMMON /TUNING/TLOG, FTUNE
         LOGICAL WTSON, WT2ON
         DIMENSION WTS(NHK2), EWTS(NHK2), MULTI(NHK2)
         DIMENSION WPOS(NHK2)
         COMMON /WPOSC/WPOS
         COMMON /WCOM/WTS, WTSON, MODE
         COMMON /WCOM2/EWTS, WT2ON
         COMMON /MPCOMM/MULTI
         COMMON /ECALC/SFERR1, ANGERR, SFERR2
         COMMON /PADCMM/NPAD
         COMMON /FOMALL/ER1, EI1, EC1, F0PASS
         INTEGER NCONT(20)
         DIMENSION CELL(6), TEMPF(20), AOCC(20), ZATOM(20)
         LOGICAL FORIG, FSEMP, BROWNF, DMULT, DMLT, FOM2
         Include 'Sfacts.h'
         COMMON /SFCOM1/TEMPF, NCONT, NATOM, CELL
         COMMON /SFCOM2/AOCC, ZATOM, FORIG, BROWNF, DMULT, DMLT
         COMMON /MVIS/WIDTH, HEIGHT, TIMES, FSEMP
         COMMON /COPT/ATNUM, PATTC, ACTERM, FOM2
         DIMENSION FSTEST(20)
         COMMON /COPT2/FSTEST
         INTEGER LAT(2)
         COMMON /CLAT/LAT
         COMMON /MSIZES/IOFFH, IOFFK
         SAVE /COPT2/ , /COPT/ , /MVIS/ , /SFCOM2/ , /SFCOM1/ 
     X   , /FOMALL/ , /MPCOMM/ , /WCOM2/ , /WCOM/ 
         DOUBLEPRECISION DD1
         PARAMETER (DD1 = 1.D0 / 6.D0)
         LOGICAL P3FLAG
         include 'NewStuff.h'
         HMAX = (-1)
         KMAX = (-1)
         RP3MAX=-1
C     largest values, trapping p3
         P3FLAG = (SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6')
C         if(p3f)p3flag=.true.
         IF (P3FLAG) THEN
           DO   N=1,NREF
C             HP3(N)=2*IH(N)
             RR=IH(N)*IH(N)+K(N)*K(N)+IH(N)*K(N)
             IF(RR.GT.RP3MAX)RP3MAX=RR
             CALL EQUIV2 (HE,KE,ISE,IH(N),K(N),NE,SYMM)
C            Setup the multiplicity common block
             MULTI(N) = NE
           END DO
C          Alternative Hmax,kmax, better
C           RP3MAX=sqrt(RP3MAX)
C           IAHMAX=NINT(2*RP3MAX+0.5)
C           IAKMAX=NINT(RP3MAX*2./sqrt(3.)+0.5)
C          HMAX=MAX(HMAX,IAHMAX)
C          KMAX=MAX(KMAX,IAKMAX)
           RP3MAX=sqrt(RP3MAX)
C       HMAX must be > 2*RP3MAX
C       KMAX must be > RP3MAX
C       In real space, want H/K = sqrt(3)
           HMAX=NINT(2*RP3MAX)
           KMAX=NINT(2*RP3MAX/sqrt(3.))
           if(printf)write(10,*)'Largest P3 Reciprocal point ',RP3MAX
         ELSE
           DO   N=1,NREF
             CALL EQUIV2 (HE,KE,ISE,IH(N),K(N),NE,SYMM)
C     Setup the multiplicity common block
             MULTI(N) = NE
             DO   J=1,NE
               HMAX = MAX (HMAX, ABS (HE(J)))
               KMAX = MAX (KMAX, ABS (KE(J)))
             END DO
           END DO
         END IF
C       Change here
C       if(printf)write(10,*)'Largest reciprocal space sampling ',hmax,kmax
C        IF(PATTC .LT. -5.0) THEN
C           WRITE (10, *) 'Old HMAX,KMAX ', HMAX,KMAX
C           IF (SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6')THEN
C                call newszp3(HP3,K,NREF,HMAX,KMAX)
C           ELSE
C                call newsize2D(IH,K,NREF,HMAX,KMAX)
C           ENDIF
C           write(10,*)'New ',HMAX,KMAX
C         ENDIF

 
C     If hmax or kmax are small, use sprres to get reasonable sizes
         SPRRES = .FALSE.
         SRES = 3.5D0
         IF (HMAX .LE. 1 .OR. KMAX .LE. 1) THEN
           SPRRES = .TRUE.
           SRES = 4.5D0
         ELSE IF (HMAX .LE. 2 .OR. KMAX .LE. 2) THEN
           SPRRES = .TRUE.
           SRES = 3.75D0
         ELSE IF (HMAX .LE. 3 .OR. KMAX .LE. 3) THEN
           SPRRES = .TRUE.
           SRES = 3.5D0
         ELSE IF (.FALSE.) THEN
           SRES = 3.5D0
         END IF
         IF (abs(FSTEST(11)) .GT. 1.1) THEN
           I1 = HMAX * FSTEST(11)
           I2 = KMAX * FSTEST(11)
         ELSE IF (SPRRES) THEN
           I1 = 1 + HMAX * SRES
           I2 = 1 + KMAX * SRES
         ELSE
           I1 = HMAX * 3 + 1
           I2 = KMAX * 3 + 1
         END IF
 
100      continue
         IF(P3FLAG .and. ((I1/6)*6 .ne. I1) )then
                I1 = (I1 /6+1) * 6
                I2 = NINT(I1/sqrt(3.))
         END IF
         CALL BESIZE (I1,I2,N1,N2)
         I1=N1
         I2=N2
         IF(P3FLAG .and. ((I1/6)*6 .ne. I1) )goto 100

         IF (PRINTF) THEN
C     write(6,*)'FFT Sizes Used: ',n1,n2
           WRITE (10, *) 'FFT Sizes Used: ', N1, N2
         END IF
         M(1) = N1
         M(2) = N2
         IF (SPRRES) THEN
           RAD1 = 3.D0 / FLOAT (N1 - 1)
           RAD2 = 3.D0 / FLOAT (N2 - 1)
         ELSE IF (FSTEST(11) .lt. -2.)then
           RAD1 = 3.D0 / FLOAT (N1 - 1)
           RAD2 = 3.D0 / FLOAT (N2 - 1)
         ELSE
           RAD1 = 1.D0 / dble(HMAX+0.25)
           RAD2 = 1.D0 / dble(KMAX+0.25)
         END IF
         RETURN
       END
       SUBROUTINE ALSIZE (N1, N2, M1, M2 )
C     All is all the values up to 2000 which are reasonable
C     best is all assuming that n1>n2 in FFT
C     This can give a factor of 2 !!!!
         INTEGER ALL(160)
         SAVE ALL
         DATA (ALL(J), J=1,80)/1,2,3,4,5,6,7,8,9,10,12,14,15,16,18,20,21
     X      ,24,25,27,28,30,32,35,36,40,42,45,48,50,54,56,60,63,64,70,72
     X      ,75,80,81,84,90,96,100,105,108,112,120,125,126,128,135,140,
     X      144,150,160,162,168,175,180,189,192,200,210,216,224,225,240,
     X      243,250,252,256,270,280,288,300,315,320,324,336/
         DATA (ALL(J), J=81,160)/350,360,375,378,384,400,405,420,432,448
     X      ,450,480,486,500,504,512,525,540,560,567,576,600,625,630,640
     X      ,648,672,675,700,720,729,750,756,768,800,810,840,864,875,896
     X      ,900,945,960,972,1000,1008,1024,1050,1080,1120,1125,1134,
     X      1152,1200,1215,1250,1260,1280,1296,1344,1350,1400,1440,1458,
     X      1500,1512,1536,1575,1600,1620,1680,1701,1728,1750,1792,1800,
     X      1875,1890,1920,1944/
         IF (N1 .LE. 1) THEN
           M1 = 1
           GO TO 10
         END IF
         DO   J=1,160
C     Trim out odd values on the fly -- murder origins!
           IF ((ALL(J) / 2) * 2 .NE. ALL(J)) ALL(J) = (-100)
           IF (N1 .LE. ALL(J)) THEN
             M1 = ALL(J)
             GO TO 10
           END IF
         END DO
   10    IF (N2 .LE. 1) THEN
           M2 = 1
           GO TO 20
         END IF
         DO   J=1,160
C     Trim out odd values on the fly -- murder origins!
           IF ((ALL(J) / 2) * 2 .NE. ALL(J)) ALL(J) = (-100)
           IF (N2 .LE. ALL(J)) THEN
             M2 = ALL(J)
             GO TO 20
           END IF
         END DO
   20    RETURN
       END
       SUBROUTINE BESIZE (N1, N2, M1, M2 )
C     best is all the values up to 2000 which are good
C     best is all assuming that n1>n2 in FFT
C     This can give a factor of 2 !!!!
C     Notes: Added 22, 28, 30, 44, 68, 108, 120, 180, 210, 270, 300, 420
C     , 480,  540, 720, 1080 to fill in holes
         INTEGER BEST(103)
         DATA BEST/1,2,3,4,5,6,7,8,9,10,12,14,16,18,20,22,24,26,28,30,32
     X      ,36,40,42,44,48,50,54,56,60,64,68,70,72,75,80,84,90,96,100,
     X      108,112,120,128,135,144,150,160,168,180,192,210,224,240,256,
     X      270,288,300,320,324,336,350,360,384,400,405,420,448,480,512,
     X      540,576,600,640,648,672,720,768,800,864,896,960,972,1024,
     X      1080,1152,1200,1215,1280,1296,1344,1350,1440,1536,1600,1620,
     X      1728,1792,1800,1875,1890,1920,1944/
         IF (N1 .EQ. 1) THEN
           M1 = 1
           GO TO 10
         END IF
         DO   J=1,103
C     Trim out odd values on the fly -- murders origin!
           IF ((BEST(J) / 2) * 2 .NE. BEST(J)) BEST(J) = (-100)
           IF (N1 .LE. BEST(J)) THEN
             M1 = BEST(J)
             GO TO 10
           END IF
         END DO
   10    IF (N2 .EQ. 1) THEN
           M2 = 1
           GO TO 20
         END IF
         DO   J=1,103
C     Trim out odd values on the fly -- murders origin!
           IF ((BEST(J) / 2) * 2 .NE. BEST(J)) BEST(J) = (-100)
           IF (N2 .LE. BEST(J)) THEN
             M2 = BEST(J)
             GO TO 20
           END IF
         END DO
   20    RETURN
       END
 
