#ifndef CRYSTALDEFS_H
#define CRYSTALDEFS_H
#include "types.h"
typedef float 	Matrix[4][4] ;
typedef float 	Vector[4] ;
typedef enum {
	kNoAnglePt,kfirstEndPoint,kVertex
} AnglePt ;
typedef enum {
	kNoPlanePt,kfirstPlanePt,ksecondPlanePt
} PlanePt ;


typedef enum {
	xRotAxis,yRotAxis,zRotAxis
} TypeRotAxis ;
#ifndef ToolTypeDefined
#define ToolTypeDefined
typedef enum  {
			XPointerTool=0,XRotateTool,XMagnifyingGlass,XRuler,XAngleTool,XSelectionTool
} XToolType ;
#endif

typedef struct {
	float cx,cy,cz ;	/* Position of the center */
	FPoint3D	corner[4] ;
	Vector normal ;
} UCellFace ;

typedef struct {
	float AngstrPrPixel ;
	Point Origin ;
	Rect  Boundary ;
} XSection ;

#endif // CRYSTALDEFS_H

