#ifndef __TFile__
#define __TFile__

#include "types.h"
#include <forms.h>

class FSInfo {
	public:
		FSInfo() ;
		Boolean		mReply ;
		char		mFileName[256] ;
} ;

typedef enum {kRead, kWrite} FileMode ;
class TFile {
	public:
		TFile() ;
		TFile(char *fileName) ;
		TFile(char *fileName,FileMode	fileMode) ;
		~TFile() ;
		FILE	*GetFP() { return mFP ; } ;
		Boolean	Open(FileMode	fileMode) ;
		void	Close() { fclose(mFP) ; mIsOpen = false ; } ; //LDM, was Boolean
		Boolean	Read() ;
		Boolean	Write() ;
		Boolean	Read(void *data,ULong numBytes) ;
		Boolean	Write(void *data,ULong numBytes) ;
		void	*GetData() { return mData ; } ;
		ULong	GetSize() { return mSize ; } ;
	private:
		FILE 		*mFP ;
		char		mFileName[256] ;
		ULong		mSize ;
		void		*mData ;
		Boolean		mIsOpen ;
} ;

void	ChooseFile(char *prompt,char *pattern,FSInfo &fsInfo) ;

#endif // __TFile__

