// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
/* Form definition file generated with fdesign. */

#include "forms.h"
#include <stdlib.h>
#include <math.h>
#include "ImportImageDialog.h"

static FL_PUP_ENTRY fdchoice_mDataType_0[] =
{ 
    /*  itemtext   callback  shortcut   mode */
    { "Integer 1 Byte Unsigned",	0,	"",	 FL_PUP_NONE},
    { "Integer 1 Byte Signed",	0,	"",	 FL_PUP_NONE},
    { "Integer 2 Byte Unsigned",	0,	"",	 FL_PUP_NONE},
    { "Integer 2 Byte Signed",	0,	"",	 FL_PUP_NONE},
    { "Integer 4 Byte Unsigned",	0,	"",	 FL_PUP_NONE},
    { "Integer 4 Byte Signed",	0,	"",	 FL_PUP_NONE},
    { "Real 4 Byte",	0,	"",	 FL_PUP_NONE},
    { "Real 8 Byte",	0,	"",	 FL_PUP_NONE},
    { "Complex 4 Byte",	0,	"",	 FL_PUP_NONE},
    { "Complex 8 Byte",	0,	"",	 FL_PUP_NONE},
    {0}
};

FD_ImportImageDialog *create_form_ImportImageDialog(long fileLength)
{
	FL_OBJECT *obj;
	char fileLengthStr[256] ;
	FD_ImportImageDialog *fdui = (FD_ImportImageDialog *) fl_calloc(1, sizeof(*fdui));

	fdui->ImportImageDialog = fl_bgn_form(FL_NO_BOX, 271, 201);
	obj = fl_add_box(FL_UP_BOX,0,0,271,201,"");
	obj = fl_add_labelframe(FL_ENGRAVED_FRAME,10,20,240,140,"Input File Information");
	obj = fl_add_text(FL_NORMAL_TEXT,20,40,100,20,"File length in bytes");
	fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
	sprintf(fileLengthStr,"%d",fileLength) ;
	fdui->mFileLength = obj = fl_add_text(FL_NORMAL_TEXT,130,40,110,20,fileLengthStr);
	fl_set_object_boxtype(obj,FL_DOWN_BOX);
	fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
	fdui->mDataType = obj = fl_add_choice(FL_NORMAL_CHOICE2,20,70,160,20,"Data Type");
	fl_set_object_lalign(obj,FL_ALIGN_RIGHT);
	fl_set_choice_entries(obj, fdchoice_mDataType_0);
	fl_set_choice(obj,7);
	fdui->mOKButton = obj = fl_add_button(FL_NORMAL_BUTTON,170,170,80,20,"OK");
	fdui->mCancelButton = obj = fl_add_button(FL_NORMAL_BUTTON,70,170,90,20,"Cancel");
	fdui->mImageWidth = obj = fl_add_input(FL_NORMAL_INPUT,20,120,70,20,"Image Width");
	fl_set_object_lalign(obj,FL_ALIGN_TOP);
	fdui->mImageHeight = obj = fl_add_input(FL_NORMAL_INPUT,170,120,70,20,"Image Height");
	fl_set_object_lalign(obj,FL_ALIGN_TOP);
	fl_end_form();

	fdui->ImportImageDialog->fdui = fdui;
	fl_set_clipping(0,0,271,201) ;

	return fdui;
	}

TImportImageDialog::TImportImageDialog(long fileLength) {
	mDialog = create_form_ImportImageDialog(fileLength);
}

TImportImageDialog::~TImportImageDialog() {
}

/**** Forms and Objects ****/
/*
typedef struct {
	FL_FORM *ImportImageDialog;
	void *vdata;
	char *cdata;
	long  ldata;
	FL_OBJECT *mFileLength;
	FL_OBJECT *mDataType;
	FL_OBJECT *mOKButton;
	FL_OBJECT *mCancelButton;
	FL_OBJECT *mImageWidth;
	FL_OBJECT *mImageHeight;
} FD_ImportImageDialog;
*/
/*---------------------------------------*/

