#ifndef __TParameterRefinementProgressPage_h_
#define __TParameterRefinementProgressPage_h_
#include "TPage.h"

class TParameterRefinementProgressPage : public TPage {
	public:
		TParameterRefinementProgressPage(TWindow *window=nil) ;
		~TParameterRefinementProgressPage() ;
		void	Draw() ;
		void	DoMouseDownInObject(TObject *obj,Point *pt) ;
		void	Initialize() ;
	private:
		void	DrawExperimentalImage() ;
		void	DrawCurrentComputedImage() ;
		TFRame *mExperimentalImageFrame;
		TFRame *mCurrentImageFrame;
		TFrame *mEnergyFrame ;
		TCheckBox *mThickness;
		TCheckBox *mDefocus;
		TCheckBox *mCrystalTilt;
		TCheckBox *mCs;
		TCheckBox *mConvergence;
		TCheckBox *mDelta;
		TCheckBox *m2FoldAstig;
		TCheckBox *m3FoldAstig;
		TStaticText *mCurrentThickness;
		TStaticText *mCurrentDefocus;
		TStaticText *mCurrentTilt;
		TStaticText *mHK0;
		TStaticText *mHKL;
		TStaticText *mCurrentCs;
		TStaticText *mCurrentConvergence;
		TStaticText *mCurrentDelta;
		TStaticText *mCurrent3FAstigValue;
		TStaticText *mCurrent3FAstigAngle;
		TStaticText *mCurrent2FAstigValue;
		TStaticText *mCurrent2FAstigAngle;
		TButton *mReturn;
		TButton *mSaveParameters;
		TStaticText *mLogFileName;

);

#endif // __TParameterRefinementProgressPage_h_

