#ifndef TResultTable_h
#define TResultTable_h


#include "TImage.h"
#include "TTable.h"


class TResultTable : public TTable {

public:
	TResultTable() ;
	TResultTable(TImage *image) ; // load the table with the result image
	TResultTable(Int16 width,Int16 height,Int16 cellSize,Int16 cellWidth,Int16 cellHeight) ; 	
	void	DrawColLabelText(Int16 colNumber) ;
	void	DrawRowLabelText(Int16 colNumber) ;
	virtual void 	DrawCellValue(TableCellT &inCell,Rect &cellFrame) ;
	void	SetDefocusLabel(short col,float value) ;
	void	SetThicknessLabel(short row,float value) ;
	virtual void	Save() ;
	virtual void	SetSuccessValues(float exactMatch,float goodMatch) ;
	
	float	mExactMatch ;
	float	mGoodMatch ;
	TableCellT	mBestCell ;
	TImage	*mImage ;		// only used in SetSuccessValues
} ;

#endif	// TResultTable

