#ifndef TSetActiveElementsForm_h_
#define TSetActiveElementsForm_h_

#include "forms.h"
#include <stdlib.h>
#include "types.h"
/**** Forms and Objects ****/
typedef struct {
	FL_FORM *mForm;
	void *vdata;
	char *cdata;
	long  ldata;
} XFormsRecord ;

class	TSetActiveElementsForm {
	public:
		TSetActiveElementsForm(FPVII callback) ;
		~TSetActiveElementsForm() ;
		void	GetActiveElements() ;
		void	Show() ;
		static	void	DoClick(FL_OBJECT *obj,long arg) ;	
	private:
		void			Initialize() ;
		XFormsRecord	*mXFormsRec ;
		FL_OBJECT 		*mOK;
		FL_OBJECT 		*mCancel;
		FL_OBJECT 		*mInactiveList;
		FL_OBJECT 		*mActiveList;
		FL_OBJECT 		*mMakeActive;
		FL_OBJECT 		*mMakeInactive;
		FPVII			mCallback ;
	
} ;

#endif // TSetActiveElementsForm_h_ 

