// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
/* ---------------------------------------------------	*/
/* Routine to get the exit wave function and perform a	*/
/* Fourier transform to get the diffraction space 		*/
/* representation of the wave							*/
/* ----------------------------------------------------	*/
#include "funcdefs.h"
void diffr(long *np,long *mp) {
	/* get the exit wave function */
	GetExitWave(np,mp) ;

	/* Fourier transform to get the wave function */
	cfft(np,mp) ;
}
