// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "header.h"
#include "menudef.h"
#include "params.h"
#include "atoms.h"
long not_equiv(float x,float y,float z,long icount,long ndx) ;
// --------------------------------------------------------------------------
// Routine to check if this is a new atom to be added     
// Returns 1 if it is, and 0 if the atom already is there  
// --------------------------------------------------------------------------
long not_equiv(float x,float y,float z,long icount,long ndx) {
	long k,xtest,ytest,ztest ;
	float xdiff,ydiff,zdiff ;

	xtest = FALSE ; ytest = FALSE ; ztest = FALSE ;
	//for (k=ndx-icount;k<ndx;k++) {
	for (k=0;k<ndx;k++) {
		if (fabs((x-(atom+k)->xc.val.fv)*gInputParameter[2].fv) < 0.1) xtest = TRUE ;
		if (fabs((y-(atom+k)->yc.val.fv)*gInputParameter[3].fv) < 0.1) ytest = TRUE ;
		if (fabs((z-(atom+k)->zc.val.fv)*gInputParameter[4].fv) < 0.1) ztest = TRUE ;
		if (xtest && ytest && ztest) {
			 return(0) ;              /* The atom already exists */
		}
		xtest = FALSE ; ytest = FALSE ; ztest = FALSE ;
	}
	return(1) ;                   /* New atom                */
}

