// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "menudef.h"
#include "devices.h"
#include "globals.h"
#include "layers.h"
#include "funcdefs.h"
#define TRUE 1
#define FALSE 0
uLong gPattern[MAXLAYERS] = {128,132,136,130,134,138,131,
135,139,133,137,129,140,150,141,149,142,148,143,147,144,146,145,
160,151,159,152,158,153,157,154,156,155,170,176,171,175,172,174,173} ;
// --------------------------------------------------------------------------
// Plots a pattern in a rectangle              
// --------------------------------------------------------------------------
void pattern(long xlow,long ylow,long xhi,long yhi,long num) {
	Rect tRect ;
	long x1,y1,x2,y2 ;

	y1 = Terminal.yres - yhi ;
	y2 = Terminal.yres - ylow ;
	x1 = xlow ;
	x2 = xhi ;
	x1 /= 2 ;
	y1 /= 2 ;
	x2 /= 2 ;
	y2 /= 2 ;

	// Instead of patterns we will use colors to differentiate the	
	// different layers					
	SetFgColor(gColors[gPattern[num-1]-gNumGrays].pixel) ;
	SetRect(&tRect,x1,y1,x2,y2) ;
	FillRect(&tRect) ;
	SetFgColor(gBlackPixel) ;
}
