// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#define PG_MASK	1
#define MS_MASK	2
#define IM_MASK	4
#define TRUE	1
extern struct { long status ; } calculation ;
void SetCalculationState() ;
// --------------------------------------------------------
// Change the flags indicating changes to the structure	
// according to the calculation state		
// --------------------------------------------------------
void SetCalculationState() {
    extern long gPGisChanged,gMSisChanged,gIMisChanged,gCalculationIsChanged ;

    if ((calculation.status & PG_MASK) == 0) {
    	gPGisChanged = TRUE ;
    	gCalculationIsChanged = TRUE ;
	}
    else if ((calculation.status & MS_MASK) == 0) {
    	gMSisChanged = TRUE ;
    	gCalculationIsChanged = TRUE ;
	}
    else if ((calculation.status & IM_MASK) == 0) {
    	gIMisChanged = TRUE ;
    	gCalculationIsChanged = TRUE ;
	}
}
