#include "header.h"
#include "funcdefs.h"
#include "menudef.h"
#include "menu_index.h"
#include "filenames.h"
extern long FILE_SELECTED,LAYERED,NUM_FILES ;
#define MAXFILES 200
extern char file_names[MAXFILES][16] ;
extern COMMAND c_files[],*m_sel_old_fl[] ;
void set_file() ;
extern long gCalculationIsChanged ;
extern char *null_text ;
extern struct { long status ;
		long oldstatus ; 
	      } calculation ;
// ---------------------------------------------------------------------
// Return from the data files and updates the data file if so requested
// ---------------------------------------------------------------------
void terminateNcemss() {

    FILE_SELECTED = FALSE ;
    if (calculation.status != calculation.oldstatus) {
		rewrite_file(flname.pin) ;
		CLEAR_DISPLAY ;
		if (LAYERED)
			set_menu(SEL_LAY_STR) ;
		else
			set_menu(SEL_SNGL_STR) ;
		displ_files() ;
		displ_menu() ;
	}
    else if (gCalculationIsChanged) {
      	gCalculationIsChanged = FALSE ;
      	eraser(0,0,1020,160) ;
      	set_menu(UPD_FILE) ;
      	displ_menu() ;
	}
    else {
      	CLEAR_DISPLAY ;
      	if (LAYERED)
        	set_menu(SEL_LAY_STR) ;
      	else
        	set_menu(SEL_SNGL_STR) ;
      	displ_files() ;
      	displ_menu() ;
	}
}

void r_upd() {
	rewrite_file(flname.pin) ;
	if (LAYERED)
	    set_menu(SEL_LAY_STR) ;
	else
	    set_menu(SEL_SNGL_STR) ;
	CLEAR_DISPLAY ;
	displ_files() ;
	displ_menu() ;
}

void r_no_upd() {
	if (LAYERED)
		set_menu(SEL_LAY_STR) ;
	else
		set_menu(SEL_SNGL_STR) ;
	CLEAR_DISPLAY ;
	displ_files() ;
	displ_menu() ;
}

void r_upd_rename() {
    char new_flname[20] ;

    eraser(0,60,1020,100) ;
    REVERSE_VIDEO ;
    temdtx(0,70," Enter a unique structure name -> ") ;
    ReadString(new_flname,20) ; 
    NORMAL_VIDEO ;
    /* Add this structure to the list of filenames so that it will show up */
    strcpy(file_names[NUM_FILES],new_flname) ;
    c_files[NUM_FILES].xl = 20 + (NUM_FILES%4)*250 ;
    c_files[NUM_FILES].xh = c_files[NUM_FILES].xl + 230 ;
    c_files[NUM_FILES].yl = 690 - (long)(NUM_FILES/4)*30 +
                                  (long)(NUM_FILES/80)*600 ;
    c_files[NUM_FILES].yh = c_files[NUM_FILES].yl + 26 ;
    c_files[NUM_FILES].action = set_file ;
    c_files[NUM_FILES].help_msg = null_text ;
    if (NUM_FILES < 80) {
		m_sel_old_fl[NUM_FILES+1] = &c_files[NUM_FILES] ;
		m_sel_old_fl[NUM_FILES+2] = &null ;
	}  
    NUM_FILES++ ;
    if (LAYERED)
		strcat(new_flname,".lay") ;
    else
		strcat(new_flname,".at") ;
    rewrite_file(new_flname) ;
    if (LAYERED)
		set_menu(SEL_LAY_STR) ;
    else
		set_menu(SEL_SNGL_STR) ;
    CLEAR_DISPLAY ;
    displ_files() ;
    displ_menu() ;
}

