#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include "funcdefs.h"
#include "header.h"
#include "menudef.h"
long writeln() ;

// ------------------------------------------------------------------------	
// function to display print files. Called by view_o_file   
// ------------------------------------------------------------------------	
void view_outfile(FILE *filep) {

	long fd,i,pos[100],itimes ;
	char resp ;

	itimes = 0 ;
	fd = fileno(filep) ;
  again :
	pos[itimes] = lseek(fd,0,1) ;
	for (i=0;i<22 && writeln()!=EOF;i++) ;
	printf("\n") ;
  tryagain :
	REVERSE_VIDEO ;
	printf("-> ") ;
	resp = getchar() ;
	NORMAL_VIDEO ;
	switch(resp) {
		case LF :
			itimes++ ;
			goto again ;
		case 'f' :
		case 'F' :
			getchar() ;
			itimes++ ;
			goto again ;
		case 'b' :
		case 'B' :
			getchar() ;
			if(itimes > 0) {
				lseek(fd,pos[--itimes],0) ;
				goto again ;
			}
			REVERSE_VIDEO ;
			printf(" Backup past top of the file !!! \n") ;
			NORMAL_VIDEO ;
			BELL ;
			goto tryagain ;
		case 'e' :
		case 'E' :
			getchar() ;
			fclose(filep) ;
			return ;
		default :
			getchar() ;
			printf("CR or F - forward , B - backward , E - return\n") ;
			goto tryagain ;
	}
}

/***********************************************************************/
/* Function to read 1 line from a given file and write to the terminal */
/***********************************************************************/
long writeln() {

	char line_out[132] ;
	extern FILE *filep ;

	if (fgets(line_out,132,filep) != NULL)
		printf("%s",line_out) ;
	else {
		REVERSE_VIDEO ;
		printf(" END OF FILE ") ;
		NORMAL_VIDEO ;
		BELL ;
		return(EOF) ;
	}
   return 0;
}

