#ifndef __TApplicationWindow__
#define __TApplicationWindow__
#include "TWindow.h"
#include "TWindowList.h"
#include "TMenuBar.h"

class	TMenuPane : public TPane {
	public:
		TMenuPane(TPane *,short ,short ,short ,short ) ; 
		TMenuPane(TPane *,Rect *) ;	
		void	SetMenuBar(TMenuBar *bar) { mMenuBar = bar ; } ;
		void	Draw() ;
	protected :
		TMenuBar	*mMenuBar ;

} ;

class TApplicationWindow : public TFrameWindow {
	public:
		TApplicationWindow(short xloc,short yloc,short width,short height,
			short depth,char *title) ;
		~TApplicationWindow() ;
		void 	Show() { TWindow::Show() ; } ;
		void	Draw() ;
		void	DoMouseDown(XEvent *event) ;
		void	DoKeyDown(XEvent *event) ;
		void	DoMenuKey(XEvent *event) ;
		void	DoMouseDownInMenuBar(Point *where) ;
		void	CreateMenuBar() ;
		void	SetCommandStatus(TMenu *theMenu,TWindow	*theTargetWindow) ;
		virtual	void	SetupMenuBar() ;
		virtual void	ActivateListener(TWindow *) {} ;
		virtual	void	DoCommand(TCommand command,Boolean *hasBeenHandled) ;
		virtual	void	GetCommandStatus(TCommand num,Boolean *isEnabled,Boolean *isChecked) ;
	protected :
		TMenuBar	*mMenuBar ;
		TMenuPane	*mMenuPane ;
		
} ;


#endif
