C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE ORIGP (H, K, FHK, I1, I2, SYMM, NREF )
C     defines origin for 2D unit cell, p1 case
C     from convergence data
         INTEGER H(*), K(*)
         DIMENSION FHK(*)
         CHARACTER*4 SYMM
         INTEGER A, B
         INTEGER HE(12), KE(12), ISE(12)
         REAL RR1
 
         I1 = (-1)
         I2 = (-1)
         UBEST = (-99.)
C     For the moment, skip p3 cases
         DO 100 J=1,NREF
 
 
C     for 2D structures, determinant of the 2x2 matrix formed must equal
C     1 or -1 if reflections are allowed to fix origin
           A = H(J)
           B = K(J)
 
           IF (H(J) .NE. 0 .OR. K(J) .NE. 0) THEN
             RR1 = FHK(J)
 
 
             DO 10 I=1,NREF
               IF (H(I) .NE. 0 .OR. K(I) .NE. 0) THEN
                 IF (I .NE. J) THEN
                   IF (ABS (A * K(I) - B * H(I)) .EQ. 1) THEN
                     CALL EQUIV2 (HE,KE,ISE,H(I),K(I),NA,SYMM)
                     CALL EQUIV2 (HE,KE,ISE,H(J),K(J),NB,SYMM)
                     UU = FHK(I) * RR1 * NA * NB
                     IF (UU .GT. UBEST) THEN
                       UBEST = UU
                       I1 = J
                       I2 = I
                     END IF
                   END IF
                 END IF
               END IF
   10        END DO
           END IF
  100    END DO
         RETURN
       END
 
