C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE SFHK (FHK, NHK, WORK, IND, NREF, NSTATS )
C     sort into the integer array ind the FHK's, then see
C     how many make up different fractions of the total
         DIMENSION FHK(*), WORK(*), IND(*), NSTATS(*)
 
C     Transfer, generate sum and mean
         SUM = 0.
         S2 = 0.
         DO   J=1,NREF
           WORK(J) = 1.D0 / (2.D0 + FHK(J))
           SUM = SUM + FHK(J)
           S2 = S2 + WORK(J)
           IND(J) = J
           IF (ABS (FHK(J) - 1.D0) .LT. 1D-4) I0 = J
         END DO
C     Remove V00
         SUM = SUM - 1.D0
 
C     Do the actual sort
         CALL SORTAG (WORK,NREF,IND)
C     Let's see how many reflections are to different percentages
C     A bit sloppy code, but it doesn't take long so .....
         DO   N=1,5
           X = FLOAT (N) * 0.1D0 * SUM
           RSUM = 0.
           DO   J=1,NREF
C     Debug
C           write(13,*)j,i,fhk(i)
             IF (IND(J) .NE. I0) THEN
               RSUM = RSUM + FHK(IND(J))
               IF (RSUM .GT. X) THEN
                 NSTATS(N) = J
                 WRITE (6, 1) 'Largest ', J, ' beams are ', N * 10, '% '
     X              , RSUM / SUM
    1            FORMAT(A,I3,A,I3,A,F10.6)
                 GO TO 100
               END IF
             END IF
           END DO
  100      CONTINUE
         END DO
         RETURN
       END
 
