      function robgenb(fhk,fw,nref,natom,occ,itype,irgcal)
      dimension fhk(*)
      complex amp,fw(*)
      dimension occ(*),itype(*),fcalc(2000)
      include 'ffact.h'
      include 'rfact.h'
      include 'GenPass.h'
      include 'errref.h'
      include 'Constraints.h'
      logical occer(200)

C      Bfactor=0.15D0
       Bfactor=1
       
C       Convert occupancies to a logical
        ntrap=0
        do n=1,natom
                if(occ(n).gt.1e-3)then
                        occer(n)=.true.
                        ntrap=ntrap+1
                else
                        occer(n)=.false.
                endif
        enddo
        if(ntrap.eq.0)then
              robgenb=999
C                 write(77,*)natom,ntrap,(occ(k),k=1,3)
              return
        endif
C       Expand occupations of atoms, then use rgcalw to fit
      jj=0
      do j=1,nrref
      amp=0
      do n=1,natom
         jj=jj+1
         if(occer(n))then
         amp=amp+fw(jj)*rfactb(itype(n),j)
C         if(j.eq.1)write(67,*)n,jj,itype(n),fw(jj)
         endif
      enddo
        fcalc(j)=amp*conjg(amp)
      enddo
      robgenb=rgcalw(rfhk,fcalc,nrref,irgcal)
      nbmp=0
C        call bothc(natom,itype,bbump,occer)
C        robgenb=robgenb+bbump*Bfactor
C      Old version
      do n=1,natom
       if(occ(n).gt.1e-3)then
               nbmp=nbmp+1
               xw(nbmp)=xr(n)
               yw(nbmp)=yr(n)
               zw(nbmp)=zr(n)
               iw(nbmp)=itype(n)
       endif
      enddo
      rbump= fbump(xw,yw,zw,nbmp,symm,iw) * bumpwt
      rbond= bonderr(xw,yw,zw,symm,nbmp,iw) * bondwt
      robgenb=robgenb+rbump + rbond
      return
      end


