C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C 
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C 
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C 
C
C subroutine ranc1 is a random number generator from Numerical Recepies
      real function ranc1(idum)
      real r(97),random
      integer ix1,ix2,ix3 
      parameter (m1=259200,ia1=7141,ic1=54773,rm1=1./m1)
      parameter (m2=134456,ia2=8121,ic2=28411,rm2=1./m2)
      parameter (m3=243000,ia3=4561,ic3=51349)
      save ix1,ix2,ix3,r
      if (idum.lt.0) then
              ix1=mod(ic1-idum,m1)
              ix1=mod(ia1*ix1+ic1,m1)
              ix2=mod(ix1,m2)
              ix1=mod(ia1*ix1+ic1,m1)
              ix3=mod(ix1,m3)
              do j=1,97
                      ix1=mod(ia1*ix1+ic1,m1)
                      ix2=mod(ia2*ix2+ic2,m2)
                      r(j)=(float(ix1)+float(ix2)*rm2)*rm1
              enddo
              idum=1
      endif
      ix1=mod(ia1*ix1+ic1,m1)
      ix2=mod(ia2*ix2+ic2,m2)
      ix3=mod(ia3*ix3+ic3,m3)
      j=1+(97*ix3)/m3
      random=r(j)
      if(random.gt.1.0d0)random=random-int(random)
      r(j)=(float(ix1)+float(ix2)*rm2)*rm1
      ranc1=random
      return
      end
      
