        subroutine min3pt(s1,s2,s3,e1,e2,e3,b,c,ifail)
C       Find an expansion of form A+Bx+Cx*x
C       Traps present (I think !)
        ifail=0
        t1=e1-e2
        t2=e1-e3
        t3=t1*(s1-s3)-t2*(s1-s2)
        tt=(s1*s1-s2*s2)*(s1-s3)-(s1*s1-s3*s3)*(s1-s2)
        if(abs(tt).lt.1e-10)then
                ifail=1
                goto 100
        endif
        C=t3/tt
        B=(t1-c*(s1*s1-s2*s2))/(s1-s2)
        if(c.lt.0)ifail=1
100     if(ifail.eq.0)return
        ifail=0
        c=0.5
        if(e2.lt.e1.and.e2.lt.e3)then
                b=-s2
        else if(e3.lt.e1.and.e3.lt.e2)then
                b=-s3
        else
                b=-s1
        endif
        return
                
        end
        subroutine min3ptd(s1,s2,s3,e1,e2,e3,stn,ifail)
C       Find an expansion of form A+Bx+Cx*x
C       Traps present (I think !)
        real*8 s1,s2,s3,e1,e2,e3,t1,t2,t3,c,b,tt,stn
        ifail=0
        t1=e1-e2
        t2=e1-e3
        t3=t1*(s1-s3)-t2*(s1-s2)
        tt=(s1*s1-s2*s2)*(s1-s3)-(s1*s1-s3*s3)*(s1-s2)
        if(abs(tt).lt.1d-14)then
                ifail=1
                stn=s1
                t=e1
                if(e2.lt.t)then
                        stn=s2
                        t=e2
                endif
                if(e3.lt.t)stn=s3
                return
        endif
        C=t3/tt
        B=(t1-c*(s1*s1-s2*s2))/(s1-s2)
        if(c.lt.0)ifail=2
        stn=-B*0.5d0/C
        return
        end

