C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE PKS2DA (F, FGOT, IND1, IND2, N1, N2, NTOT, TOL, SYMM,
     X    DX, DY, CUT )
         INTEGER IND1(*), IND2(*)
         PARAMETER (NP = 5000)
         INTEGER IO1(5000), IO2(5000), IND(5000)
         DIMENSION F(*), FGOT(*), WORK(5000)
         DIMENSION FG(5000)
         CHARACTER*4 SYMM
         DOUBLEPRECISION DD1
         PARAMETER (DD1 = -1D6)
C         INTEGER II2, II3, II4, II5, II6, II7, II8, II9
         REAL RR1
         LOGICAL LL2, LL3, LL5
         DOUBLEPRECISION DFERR1, DFERR2
         COMMON /ECALCD/DFERR1, DFERR2
C     First, search for maximum
         FMAX = DD1
         JJ = 0
         LL3 = SYMM .EQ. 'p2mm' .OR. SYMM .EQ. 'c2mm' .OR. SYMM .EQ.
     X      'p6mm' .OR. SYMM .EQ. 'p3m1' .OR. SYMM .EQ. 'p31m'
         II2 = N2 / 2 + 2
         II3 = N1 / 2 + 2
         DO 91 J2=1,N2
C           LL1 = LL3
           LL2 = J2 .GT. II2
C           II1 = II3
           DO 91 J1=1,N1
             JJ = JJ + 1
             IF (LL3) THEN
               IF (LL2) GO TO 91
               IF (J1 .GT. II3) GO TO 91
             END IF
             IF (F(JJ) .GT. FMAX) THEN
               FMAX = F(JJ)
             END IF
   91   CONTINUE
C
C       Large points
   10    FMIN = FMAX * CUT
         JJ = 0
         IGOT = 0
C         LL6 = SYMM .EQ. 'p2mm' .OR. SYMM .EQ. 'c2mm' .OR. SYMM .EQ.
C     X      'p6mm' .OR. SYMM .EQ. 'p3m1' .OR. SYMM .EQ. 'p31m'
         II2 = N2 / 2 + 2
         II3 = N1 / 2 + 2
         DO 92 J2=1,N2
C           LL4 = LL6
           LL5 = J2 .GT. II2
C           II4 = II6
           DO 92 J1=1,N1
             JJ = JJ + 1
             IF (LL3) THEN
               IF (LL5) GO TO 92
               IF (J1 .GT. II3) GO TO 92
             END IF
             IF (F(JJ) .GT. FMIN) THEN
               IGOT = IGOT + 1
               IF (IGOT .GT. 5000) THEN
                 CUT = CUT * 1.25D0
                 GO TO 10
               END IF
               IO1(IGOT) = J1
               IO2(IGOT) = J2
               FG(IGOT) = F(JJ) / FMAX
             END IF
   92      CONTINUE
 
C       sort
         DO   L=1,IGOT
           RR1 = FG(L)
           WORK(L) = 1.D0 / (1.D0 + RR1)
           IND(L) = L
         END DO
         CALL SORTAG (WORK,IGOT,IND)
 
C     Now do a running search
         DO 101 L=2,IGOT
C     Check proximity
C     Trap case when we have a slope of a streaked atom
C     eliminate if adjacent points are larger
           L1 = IO1(IND(L))
           L2 = IO2(IND(L))
           FF = FADD2D (F,L1,L2,N1,N2)
           L1 = IO1(IND(L)) - 1
           L2 = IO2(IND(L))
           F1 = FADD2D (F,L1,L2,N1,N2)
           IF (F1 .GT. FF) FG(IND(L)) = (-1.)
           L1 = IO1(IND(L)) + 1
           L2 = IO2(IND(L))
           F2 = FADD2D (F,L1,L2,N1,N2)
           IF (F2 .GT. FF) FG(IND(L)) = (-1.)
           L1 = IO1(IND(L))
           L2 = IO2(IND(L)) - 1
           F3 = FADD2D (F,L1,L2,N1,N2)
           IF (F3 .GT. FF) FG(IND(L)) = (-1.)
           L1 = IO1(IND(L))
           L2 = IO2(IND(L)) + 1
           F4 = FADD2D (F,L1,L2,N1,N2)
           IF (F4 .GT. FF) FG(IND(L)) = (-1.)
           IF (FG(IND(L)) .GE. 0) THEN
             II7 = IND(L)
             II8 = IO1(II7)
             II9 = IO2(II7)
             DO 100 II=1,L-1
               IF (FG(IND(II)) .GE. 0) THEN
                 I1 = II8 - IO1(IND(II))
                 I2 = II9 - IO2(IND(II))
                 I1 = MIN (ABS (I1), ABS (I1 - N1), ABS (I1 + N1))
                 I2 = MIN (ABS (I2), ABS (I2 - N2), ABS (I2 + N2))
                 IF (I1 * I1 * DX + I2 * I2 * DY .LT. TOL) THEN
                   FG(II7) = (-1.)
                   GO TO 101
                 END IF
               END IF
C     Done loop (I hope)
  100          CONTINUE
           END IF
  101      CONTINUE
 
         IGG = 0
         DO 201 L=1,IGOT
           IF (FG(IND(L)) .GE. 0) THEN
             IGG = IGG + 1
             FGOT(IGG) = FG(IND(L))
             IND1(IGG) = IO1(IND(L))
             IND2(IGG) = IO2(IND(L))
             IF (IGG .EQ. NTOT) RETURN
           END IF
  201      CONTINUE
         NTOT = IGG
         RETURN
       END

