       subroutine redatoms(x,y,z,f,n,symm)
C      Reduce a set of positions to the smallest ones in unit cell
C      Remove positions that are very close
C      Only in 2D at the moment
       dimension x(*),y(*),z(*),f(*)
       character*4 symm
       logical ok(500),dist2D
       dimension xe(20),ye(20)
       dimension wx(500),wy(500),wz(500),wf(500)
       tol=0.25D0
       do j=1,n
          ok(j)=.true.
C         Reduce to smallest (kind-of) value
          call asuwnt(x(j),y(j),symm)
C         Cleanup special points
          call cleaner(x(j),y(j),symm,tol)
       enddo
C      Now search
       do j=1,n-1
        if(ok(j))then
             call asymm(x(j),y(j),ne,xe,ye,symm)
             do m=1,ne
             do k=j+1,n
               dx=xe(m)-x(k)
               dy=ye(m)-y(k)
               dx=dx-nint(dx)
               dy=dy-nint(dy)
               if(dist2D(dx,dy,tol))ok(k)=.false.
             enddo
             enddo
        endif
      enddo
C     Clumsy (but safe) shuffle
      m=0
      do j=1,n
         if(ok(j))then
            m=m+1
            wx(m)=x(j)
            wy(m)=y(j)
            wz(m)=z(j)
            wf(m)=f(j)
         endif
      enddo
      do j=1,m
         x(j)=wx(j)
         y(j)=wy(j)
         z(j)=wz(j)
         f(j)=wf(j)
      enddo
      write(6,*)'Reduced from ',n,' to ',m
      n=m
      return
      end

