C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       subroutine TMODMASK (IH, K, FMODEL, AMODEL, SYMM, C, M )
C
         include 'Nlimit.h'
C         PARAMETER (NHK2 = 900, NLIMIT = 65536)
         LOGICAL PRINTF
         COMMON /PRINTS/PRINTF
C         DIMENSION WINWTS(NHK2)
C         COMMON /FOM5/WINWTS
         LOGICAL PWMASK, EOPT, PWACC, PMACC
         COMMON /WALSH/PWMASK, EOPT, PWACC, PMACC
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
C     data centro /.false./
         COMMON /ERRTRY/NWOPT
         COMMON /ENTC2D/RAD1, RAD2
 
C     For tuning
         LOGICAL TLOG(6)
         DIMENSION FTUNE(4)
         COMMON /TUNING/TLOG, FTUNE
         LOGICAL WTSON, WT2ON
         DIMENSION WTS(NHK2), EWTS(NHK2), MULTI(NHK2)
         DIMENSION WPOS(NHK2)
         COMMON /WPOSC/WPOS
         COMMON /WCOM/WTS, WTSON, MODE
         COMMON /WCOM2/EWTS, WT2ON
         COMMON /MPCOMM/MULTI
         COMMON /ECALC/SFERR1, ANGERR, SFERR2
         COMMON /PADCMM/NPAD
         COMMON /FOMALL/ER1, EI1, EC1, F0PASS
         DIMENSION IH(*), K(*),  AMODEL(*),FMODEL(*)
         INTEGER HE(20), KE(20), ISE(20), M(3)
         COMPLEX C(*), W1
         LOGICAL CFLAG
         CHARACTER*4 SYMM
         LOGICAL LL1
         COMPLEX CC1, CC3, CC5, CC7, CC9, CC11
     X      , CC13, CC15
         Include 'TModel.h'
C     Origin for arrays (for consistency with FFT's)
         N1 = M(1)
         N2 = M(2)
         N1C = M(1) / 2 + 1
         N2C = M(2) / 2 + 1
 
C     Angle conversion scaler
         PI = ASIN (1.D0) * 2.D0
         PI2 = PI * 2
 
         DO   J=1,M(1)*M(2)
           C(J) = (0., 0.)
         END DO

C     setup in c the symmetry related values
         FMAX = (-10.)
C         CC18 = CMPLX (0.D0, 1.D0)
         II1 = M(1)

         DO   J=1,NPAD
           IHH = IH(J)
           IKK = K(J)
           CALL EQUIV2 (HE,KE,ISE,IHH,IKK,NE,SYMM)
           F = FMODEL(J)
           ANG = AMODEL(J)
           IF (ISE(1) .EQ. 3 .AND. ABS (AMODEL(J)) .GT. 1D-4) THEN
C     truncate angle to moduli pi provided that > a cutoff
             IA = NINT (AMODEL(J) / PI)
             IF (NINT (AMODEL(J) / PI) .EQ. 0) IA = 2
             ANG = PI * IA
             AMODEL(J) = PI * IA
           END IF
           IF (IHH .EQ. 0 .AND. IKK .EQ. 0) THEN
             COSAN = 1.
             SINAN = 0.
             F = 1.
           ELSE IF (ABS (ANG) .LT. 1D-4) THEN
             F = 0.
             COSAN = 0.
             SINAN = 0.
           ELSE
             IF (FMODEL(J) .GT. FMAX) FMAX = FMODEL(J)
             COSAN = COS (ANG) * FMODEL(J)
             SINAN = SIN (ANG) * FMODEL(J)
           END IF
C     Information about symmetry coding of phases
           LL1 = SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6'
           CC1 = CMPLX (COSAN, -SINAN)
           CC3 = CMPLX (COSAN, 0.D0)
           CC5 = CMPLX (0.D0, SINAN)
           CC7 = CMPLX (COSAN, SINAN)
           CC9 = -CC7
           CC11 = -CC1
           CC13 = -CC3
           CC15 = CMPLX (0.D0, -SINAN)
           DO   JJ=1,NE
C     trap problems with p3 symmetry to give rectangular axes
             IF (LL1) THEN
               CALL P3EXP (IHJJ,IKJJ,HE(JJ),KE(JJ))
               IHJJ = IHJJ + N1C
               IKJJ = IKJJ + N2C
             ELSE
               IHJJ = HE(JJ) + N1C
               IKJJ = KE(JJ) + N2C
             END IF
             IF (ISE(JJ) .LT. 0) THEN
               W1 = CC1
             ELSE IF (ISE(JJ) .EQ. 3) THEN
               W1 = CC3
             ELSE IF (ISE(JJ) .EQ. 6) THEN
               W1 = CC5
              ELSE IF (ISE(JJ) .LT. 8) THEN
               W1 = CC7
             ELSE IF (ISE(JJ) .LT. 110) THEN
               AWORK = ANG + HE(1) * PI
               W1 = F * CMPLX (COS (AWORK), SIN (AWORK))
C     X or Y-glide
             ELSE IF (ISE(JJ) .LT. 210) THEN
               W1 = CC9
             ELSE IF (ISE(JJ) .EQ. 300) THEN
               W1 = CC11
C     p2mg case
             ELSE IF (ISE(JJ) .EQ. 1000) THEN
               W1 = CC13
             ELSE IF (ISE(JJ) .EQ. 2000) THEN
               W1 = CC15
             END IF
C     Put model into complex part
             C((IKJJ-1)*II1+IHJJ) = CONJG(W1)
           END DO
C     endif
         END DO
C
C        Convert to real space
         CALL FFT2DN (C)
C           Correction for the origin shift
         JK = 0
         MF = (-1)
         XMAX=-1
         DO   I=1,N2
           MF = -MF
           NF = -MF
           DO   J=1,N1
             JK = JK + 1
             NF = -NF
             XR = MAX( DBLE(C(JK)) * NF, 0.D0)
             C(JK) = XR
             IF(XR.gt.xmax)xmax=xr
           END DO
         END DO
C        Generate a mask
         JK=0
         S1=0
         S2=0
         XMAX=1./XMAX
         DO J=1,n2
            DO I=1,N1
               JK=JK+1
               call filter(C,XQ,I,J,N1,N2)
               XQ=XQ*XMAX
               IF(XQ.GE.0.1)then
                 FILT(JK)=1.0
C               ELSE IF(XQ.GT.0.)THEN
C                 FILT(JK)=sin(XQ*PI*2.5)
               ELSE
                 FILT(JK)=0
               ENDIF
            ENDDO
        ENDDO
C        call debpic(N1,N2,FILT,1)
         RETURN
       END
C        subroutine filter(f,filt,j1,j2,j3,n1,n2,n3)
        subroutine filter(f,filt,j1,j2,n1,n2)
        complex f(*)
        logical initialize
        save initialize,rsum
        data initialize/.true./
        parameter (ifilt=4, fltwt=0.5)
        filt=0
        nn=n2*n1
        if(initialize)then
        initialize=.false.
        rsum=0
        do i2=-ifilt,ifilt
          r1=i2*i2
          do i1=-ifilt,ifilt
            rr=i2*i2+i1*i1
            wt=exp(-rr*fltwt)
            rsum=rsum+wt
          enddo
        enddo
        rsum=1./rsum
        endif
        
        do i2=-ifilt,ifilt
           k2=i2+j2
           if(k2.gt.n2)k2=k2-n2
           if(k2.lt.1)k2=k2+n2
           r1=i2*i2
           do i1=-ifilt,ifilt
              k1=i1+j1
              if(k1.gt.n1)k1=k1-n1
              if(k1.lt.1)k1=k1+n1
              k=(k2-1)*n1+k1
              r2=i1*i1
              rr=i2*i2+i1*i1
              wt=exp(-rr*fltwt)
              filt=filt+real(f(k))*wt
            enddo
        enddo
        filt=filt*rsum
        return
        end

