C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE SHPT2D (N1, N2, M, C, IOPT, X1, X2 )
         COMPLEX C(*)
         INTEGER M(3), N1, N2, IOPT
         DOUBLEPRECISION XMEAN, XR, XI
         DOUBLEPRECISION XT,BCUT, XFLIP
         include 'NewStuff.h'
         LOGICAL  UFLIP
C     Positivity constraint as well
C     Do a FFT
C        write(10,*)'Debug ',X1
         CALL FFT2DN (C)
         UFLIP=.false.
         if(flip  .gt. 1e-4)then
                uflip=.true.
                XFLIP=FLIP/DBLE(N1*N2)
         else
                XFLIP=1./DBLE(N1*N2)
         endif
         F1=1
         F2=1
C
        INCLUDE 'EntScales.h'
        IF(UFLIP6)then
         JK = 0
         MF = (-1)
         XLMAX=-1
         DO   I=1,N2
           MF = -MF
           NF = (-MF)
           DO   J=1,N1
             JK = JK + 1
             NF = -NF
             XT = dble(C(JK))
             IF (NF .LT. 0) XT=-XT
             IF (XT .gt. XLMAX) XLMAX=XT
           ENDDO
         ENDDO
C       Or
        XFLIP = XLMAX*XFCUT*FLIP
C         XFLIP = XLMAX*FLIP*0.01
         ENDIF
        if(uflip2)then
        sum = 0
        sum2= 0
        sumsq=0
        sumsq2=0
         JK = 0
         MF = (-1)
         DO   I=1,N2
           MF = -MF
           NF = (-MF)
           DO   J=1,N1
             JK = JK + 1
             NF = -NF
             XT = dble(C(JK))
             IF (NF .LT. 0) XT=-XT
                IF(XT .gt. XFLIP)then
                        sum=sum+xt
                        sumsq=sumsq+xt*xt
                else
                        sum2=sum2-xt
                        sumsq2=sumsq2+xt*xt
                endif
        enddo
        enddo
C
C       Want f1, f2 such that
C       f1*sum   + f2*sum2   = sum - sum2
C       f1*sumsq + f2*sumsq2 = sumsq + sumsq2
        det = sum*sumsq2 - sum2*sumsq
        a11 = sum
        a12 = sum2
        a21 = sumsq
        a22 = sumsq2
        f1 = ( a22*(sum-sum2)-a12*(sumsq+sumsq2))/det
        f2 = (-a21*(sum-sum2)+a11*(sumsq+sumsq2))/det
C
        t1=f1*sum+f2*sum2-(sum-sum2)
        t2=f1*sumsq+f2*sumsq2-(sumsq+sumsq2)
C        write(10,*)'Debug ',t1,t2,f1,f2
         if(f1 .lt. 0)then
                f1=1
                f2=1
         endif
         write(10,*)'Debug ',f1,f2,sum,sum2,sumsq,sumsq2

         endif
C
         JK = 0
         MF = (-1)
         DO   I=1,N2
           MF = -MF
           NF = (-MF)
           DO   J=1,N1
             JK = JK + 1
             NF = -NF
             XT = dble(C(JK))
             IF (NF .LT. 0) XT=-XT
             IF(LENT4)then
                IF (XT .LT. BCUT) THEN
                        XI = -XT * X2
                        IF (XT .LT. -XMEAN ) THEN
                                XR = 0.D0
                        ELSE
                                XR = XT * LOG(abs(XT)/XMEAN)
                        ENDIF
                ELSE
                        XR = XT * LOG (XT/XMEAN)
                        XI = XT
                        if(LENT1)
     X                  XI=-XT*LOG(XT*ENTMUL)*ENTSCL
                END IF
             ELSE
                IF (XT .LT. BCUT ) THEN
                        XR = 0.D0
                        XI = -XT*X2
                ELSE
                        XR = XT * LOG (XT/XMEAN)
                        XI = XT
                        if(LENT1)
     X                  XI=-XT*LOG(XT*ENTMUL)*ENTSCL
                END IF
             ENDIF
             IF(UFLIP .AND. (XT .LT. XFLIP))then
                XI=-XT*F2
             else
                XI=XT*F1
             endif
C             IF(LENT7 .and. (XT .lt. XFLIP))XT=0
             IF(NF .LT. 0)then
                XR = - XR
                XI = - XI
             ENDIF 
             C(JK) = CMPLX (XR, XI)
           END DO
         END DO
C      write(10,*)'TTT ',xmax/xmean , xflip/xmean
C     Invert
         CALL FFT2DP (C)
         RETURN
       END
 
C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE SHPFLIP (N1, N2, C)
         COMPLEX C(*)
         INTEGER N1, N2
         DOUBLEPRECISION XMEAN, XR, XI
         DOUBLEPRECISION XT,BCUT, XFLIP
         include 'NewStuff.h'
         LOGICAL  UFLIP
C     Positivity constraint as well
C     Do a FFT
C        write(10,*)'Debug ',X1
         CALL FFT2DN (C)
C
        INCLUDE 'EntScales.h'
         JK = 0
         MF = (-1)
         XLMAX=-1
         DO   I=1,N2
           MF = -MF
           NF = (-MF)
           DO   J=1,N1
             JK = JK + 1
             NF = -NF
             XT = dble(C(JK))
             IF (NF .LT. 0) XT=-XT
             IF (XT .gt. XLMAX) XLMAX=XT
           ENDDO
         ENDDO
        XFLIP = XLMAX*XFCUT*FLIP
C
        sum = 0
        sum2= 0
        sumsq=0
        sumsq2=0
         JK = 0
         MF = (-1)
         DO   I=1,N2
           MF = -MF
           NF = (-MF)
           DO   J=1,N1
             JK = JK + 1
             NF = -NF
             XT = dble(C(JK))
             IF (NF .LT. 0) XT=-XT
                IF(XT .gt. XFLIP)then
                        sum=sum+xt
                        sumsq=sumsq+xt*xt
                else
                        sum2=sum2-xt
                        sumsq2=sumsq2+xt*xt
                endif
        enddo
        enddo
C
C       Want f1, f2 such that
C       f1*sum   + f2*sum2   = sum - sum2
C       f1*sumsq + f2*sumsq2 = sumsq + sumsq2
C        det = sum*sumsq2 - sum2*sumsq
C        a11 = sum
C        a12 = sum2
C        a21 = sumsq
C        a22 = sumsq2
C        f1 = ( a22*(sum-sum2)-a12*(sumsq+sumsq2))/det
C        f2 = (-a21*(sum-sum2)+a11*(sumsq+sumsq2))/det
C
C        t1=f1*sum+f2*sum2-(sum-sum2)
C        t2=f1*sumsq+f2*sumsq2-(sumsq+sumsq2)
C        write(10,*)'Debug ',t1,t2,f1,f2
         f1 = (sum - 2*sum2)/sum
         f2 = 1
         if(f1 .lt. 0)then
                f1=1
                f2=1
         endif
         write(10,*)'Debug ',f1,f2,sum,sum2,sumsq,sumsq2
C
         JK = 0
         MF = (-1)
         DO   I=1,N2
           MF = -MF
           NF = (-MF)
           DO   J=1,N1
             JK = JK + 1
             NF = -NF
             XT = dble(C(JK))
             IF (NF .LT. 0) XT=-XT
             IF (XT .LT. BCUT ) THEN
                        XR = 0.D0
             ELSE
                        XR = XT * LOG (XT/XMEAN)
             END IF
             if(XT .lt. XFLIP) then
                XI = -XT*f2
             else
                XI =  XT*f1
             endif
             IF(NF .LT. 0)then
                XR = - XR
                XI = - XI
             ENDIF 
             C(JK) = CMPLX (XR, XI)
           END DO
         END DO
C     Invert
         CALL FFT2DP (C)
         RETURN
       END
 
