/*
 * atomf.h  (for atomf.c)
 */

typedef struct {double a1,b1,a2,b2,a3,b3,a4,b4,c,znum;} XDT;
typedef struct {double a1,b1,a2,b2,a3,b3,a4,b4;} EDT;

/*
typedef XDT *XDT_VECTOR;
XDT_VECTOR new_xdt_vector(int n);
void free_xdt_vector(XDT_VECTOR v);
*/


/*XDT read_xray_asf_table(char *element); */
XDT read_xdt_table(char *element);
double xray_asf( double sq_s, XDT xdyl );

double atom_scat_f_dtx( double sq_s, XDT xdyl );
double atomsf_xdt( double sq_s, XDT xdyl );		/* Improved Mott formula (L.M.Peng) */
double atom_f_absorption( double sq_s, double f_absrp_0, double b_factor );
	/* absorptive f (Ichimiya) */
double atom_z_xdt( XDT xdyl );	/* Z number */
