// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
/* Form definition file generated with fdesign. */

#include "forms.h"
#include <stdlib.h>
#include "PutMessage.h"
void	ProcessModalEvent(XEvent *event) ;

FD_Message *create_form_Message(char *text)
{
  FL_OBJECT *obj;
  FD_Message *fdui = (FD_Message *) fl_calloc(1, sizeof(*fdui));

  fdui->Message = fl_bgn_form(FL_NO_BOX, 401, 161);
  obj = fl_add_box(FL_UP_BOX,0,0,401,161,"");
  fdui->okayButton = fl_add_button(FL_NORMAL_BUTTON,300,110,90,30,"Okay");
  obj = fl_add_text(FL_NORMAL_TEXT,20,20,370,80,text);
  fl_set_object_lalign(obj,FL_ALIGN_TOP_LEFT|FL_ALIGN_INSIDE);
  fl_end_form();

  fdui->Message->fdui = fdui;
	fl_set_clipping(0,0,401, 161) ;

  return fdui;
}

TMessage::TMessage(char *text) {
  	FL_OBJECT *obj;
	mMessage = create_form_Message(text) ;
	fl_show_form(mMessage->Message,FL_PLACE_CENTER,FL_TRANSIENT,"Message") ;
}

TMessage::~TMessage() {
	fl_hide_form(mMessage->Message) ;
	fl_free_form(mMessage->Message) ;
}

void PutMessage(char *text) {
	TMessage *theMessage = new TMessage(text) ;
	XEvent	event ;
	FL_OBJECT *obj;
	do {
		obj = fl_do_forms() ;
		if (obj == FL_EVENT) {
			fl_XNextEvent(&event) ;
			ProcessModalEvent(&event) ;
		}
	} while (obj != theMessage->mMessage->okayButton) ;
	// Process form until the OK button is clicked
	delete theMessage ;
	
}
/*---------------------------------------*/

