// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include menudef
#include header
#include <uisentry.h>
#include <uisusrdef.h>
void dispatch(COMMAND *item){
  /* ----------------------------------------------------------- */
  /* Make sure we only dispatch if the left button is PRESSED    */
  /* and not released and the Key is active                      */
  /* ----------------------------------------------------------- */
    long i ;
    extern struct kb_state_bits keybuf ;

/*    if (!item.visible) return ; */
    if (keybuf.UIS$W_KEY_CODE==UIS$C_POINTER_BUTTON_1 && 
        keybuf.UIS$V_KEY_DOWN) 
      {
         /* Find out the number in the menu that got invoked */
         for (i=0,eventptr=(*menuptr);*eventptr != item;eventptr++,i++) ;
         highli_off(item) ;    /* Turn off any highlight associated with
                                  cursor movement 
                                */
         (*item->action)(i) ;
       }
     else if (keybuf.UIS$W_KEY_CODE==UIS$C_POINTER_BUTTON_2 && 
        keybuf.UIS$V_KEY_DOWN) 
       {
        /* Output help message on the command */
         /* Find out the number in the menu that got invoked */
         for (i=0,eventptr=(*menuptr);*eventptr != item;eventptr++,i++) ;
         pr_help_msg(item) ;
       }
  }
