#include "header.h"
#include "menudef.h"
#include "devices.h"
#include "globals.h"
void DrawControl(COMMAND *control) ;
void HighlightControl(COMMAND *control) ;
void on_off(COMMAND *item) ;
// ---------------------------
// Turn commands on/off
// ---------------------------
void on_off(COMMAND *item) {
	switch(item->status)	{
		case ON:	// Turn the item OFF 
			DrawControl(item) ;
			item->status = OFF ;
			break ;
		case OFF:	// Turn the item ON
			HighlightControl(item) ;
			item->status = ON ;
			break ;
	}
}
