// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include <stdio.h>
#include <sys/file.h>
#include <stdlib.h>
#include "globals.h"
void send_ps_file() ;
// --------------------------------------------------------
// Send the file "laserprinter.ps" to the
// laserprinter. In this case, there is a SYSTEM command 
// or symbol "laser" that sends the file to the printer
// --------------------------------------------------------
void send_ps_file() {
    char command [256] ;

    if (gPostscriptToFile) {
	sprintf(command,"mv laserprinter.ps %s",gPostscriptFileName) ;
    }
    else {
	sprintf(command,"lpr laserprinter.ps") ;
    }
    system(command) ;
}
