#include "header.h"
#include "atoms.h"
// ---------------------------------------------------------------
// Function to determine the number of different atom-types in the  
// structure                                                      
// ---------------------------------------------------------------
long types(AtomRecPtr unit,long natom) {

	long i,j,ntype,equal ;
	float debye[100] ;
	char *symb[100] ;

	ntype = 1 ;
	symb[0] = unit->name.val.cv ;
	debye[0] = unit->dw.val.fv ;
	unit->type.val.iv = 1 ;

	for (j=1;j<natom;j++) {
		equal = FALSE ;
		for (i=0;i<ntype;i++)
			if ((unit+j)->name.val.cv == symb[i] &&
					(unit+j)->dw.val.fv == debye[i]) {
				equal = TRUE ;
				(unit+j)->type.val.iv = i+1 ;
				break ;
			}
		if (!equal) {
			symb[ntype] = (unit+j)->name.val.cv ;
			debye[ntype] = (unit+j)->dw.val.fv ;
			(unit+j)->type.val.iv = ++ntype ;
		}
	}
	return(ntype) ;
}

